//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include <alloc.h>
#include <stdio.h>
#include <dos.h>
#include <stdlib.h>

#include "Unit1.h"
#include "Unit2.h"
#include "Unit3.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "TrayComp"
#pragma resource "*.dfm"
TForm1 *Form1;
char *errormsg1="HTTP/1.1 500 InternalError\n"
    "Connection: close\nContent-Length: 0\n\n";
char *testmsg1="HTTP/1.1 200 OK\n"
    "Content-Type: text/plain\nContent-Length: 16\n\n"
    "OK. Test passed.";
char *TempStdinFile="t_in.tmp", TempStdoutFile[20];
char *TempStderrFile="t_err.tmp"/* TempStderrFile[20] */;
#define CGI_ENV_SIZE 5000
char CgiEnvString[CGI_ENV_SIZE];
#define HEAD_MAX_LEN 8000
#define BODY_MAX_LEN 2000
enum { //types of CGI/SSI apps/files
    CGITYPE_DEFAULT,
    CGITYPE_EXE,
    CGITYPE_SCRIPT
};
//extern PACKAGE AnsiString __fastcall HTTPDecode(const AnsiString AStr);
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
    : TForm(Owner)
{
    int tzM, tzh, tzm;
    TIME_ZONE_INFORMATION tzi;
    DWORD tzdw;
    AnsiString TZinfo;
    logFileName = "hserver.log";
    SetCurrentDir(ExtractFilePath(ParamStr(0)));
    RootCatalog = "C:";
    ParserList = new mParserList();
    //FStreams = new mFileStreams();
    LogSessions = LogConnects = true;
    LogFiles = LogHeaders = false;
    SessionTotalConnects = 0;  SessionTotalRequests = 0;
    SessionTotalErrors = 0;  SessionTotalDeniedIPs = 0;
    Lang = 1; //english
    ShowRuntimeStatistics = true;  ShowCatalogContents = true;
    HideOnStart = false;
    LogDebug = LogRemoteHosts = false;
    UseIPFiltering = false;  SendServerHeader = false;
    CGIDir = "/cgi-bin/";
    EnableCGI = true;  UseSepCGIFolder = false;
    DenieNonprogramsInCGI = false;  DeniePointAtFirst = true;
    AllErrorsAsStatusCodes = true;  DuplicateIPInVar = false;
    DuplicateIPVar = "HTTP_X_FORWARDED_FOR";
//    Registry = new TRegistry();
//    Registry->RootKey = HKEY_LOCAL_MACHINE;
//work with registry see in the end of constructor
    MIMETypes = new TStringList();
    IPFilters = new TStringList();
    CGIAssociations = new TStringList();
    RootList = new TStringList();
    KillLogOnExit = false;
    Use403 = false;
    // debug:
    //ErrorFile404="F:\\www\\shs\\dobro_ban\\404.htm"; ErrorFile500="";
    // /debug
    Application->OnException = AppException;
    /*MIMETypes->Add(";zip;;arj;;z;;gz;;tar;;ace;;ice;;ain;;cab;"
        ":application/x-compressed"); */
    MIMETypes->Add(";htm;;html;;shtm;;sht;;shtml;;dhtm;;dht;;dhtml;"
        ";xhtm;;xht;;xhtml;;phtm;;pht;;phtml;"
        ":text/html");
    MIMETypes->Add(";xml;;xsl;"
        ":text/xml");
    MIMETypes->Add(";txt;;ans;;rus;;nfo;;me;;log;"
        ":text/plain");
    MIMETypes->Add(";js;"
        ":text/javascript");
    MIMETypes->Add(";vbs;"
        ":text/vbscript");
    MIMETypes->Add(";gif;"
        ":image/gif");
    MIMETypes->Add(";jpg;;jpe;;jfif;;jpeg;"
        ":image/jpeg");
    MIMETypes->Add(";png;"
        ":image/png");
    MIMETypes->Add(";tiff;;tif;"
        ":image/tiff");
    MIMETypes->Add(";xbm;"
        ":image/x-xbitmap");
    MIMETypes->Add(";art;"
        ":image/x-jg");
    MIMETypes->Add(";bmp;"
        ":image/bmp");
    MIMETypes->Add(";ivf;"
        ":video/x-ivf");
    MIMETypes->Add(";qt;;mov;"
        ":video/quicktime");
    MIMETypes->Add(";avi;"
        ":video/avi");
    MIMETypes->Add(";enc;;mpg;;m1v;;mpa;;mpe;;mpeg;;mpv2;"
        ":video/mpeg");
    MIMETypes->Add(";asf;;lsf;;asr;;asx;;lsx;"
        ":video/x-ms-asf");
    MIMETypes->Add(";vdo;"
        ":video/vdo");
    MIMETypes->Add(";aiff;;aif;;aifc;"
        ":audio/aiff");
    MIMETypes->Add(";au;;snd;"
        ":audio/basic");
    MIMETypes->Add(";wav;"
        ":audio/wav");
    MIMETypes->Add(";hta;"
        ":application/hta");
    MIMETypes->Add(";rar;"
        ":application/x-rar-compressed");
    MIMETypes->Add(";doc;;wiz;;dot;"
        ":application/msword");
    MIMETypes->Add(";xls;;xlb;"
        ":application/vnd.ms-excel");
    MIMETypes->Add(";ppt;;pps;;pwz;;ppa;;pot;"
        ":application/vnd.ms-powerpoint");
    MIMETypes->Add(";pdf;"
        ":application/pdf");
    MIMETypes->Add(";fdf;"
        ":application/vnd.fdf");
    MIMETypes->Add(";cab;"
        ":application/x-compressed");
    MIMETypes->Add(";iii;"
        ":application/x-iphone");
    MIMETypes->Add(";ins;;isp;"
        ":application/x-internet-signup");
    MIMETypes->Add(";mhtml;;mht;;eml;;nws;"
        ":message/rfc822");
    MIMETypes->Add(";pfx;;p12;"
        ":application/x-pkcs12");
    MIMETypes->Add(";prf;"
        ":application/pics-rules");
    MIMETypes->Add(";ra;;rm;;rmm;;ram;"
        ":audio/x-pn-realaudio");
    MIMETypes->Add(";rts;"
        ":application/x-rtsl");
    MIMETypes->Add(";spl;;swf;"
        ":application/futuresplash");
    MIMETypes->Add(";wrz;;vrml;;wrl;"
        ":model/vrml");
    MIMETypes->Add(";it;;xm;;s3m;;stm;;mod;;dsm;;med;;ult;"
        ";mm;;669;;mp3;;mp2;;mp1;"
        ":audio/mpeg");
    MIMETypes->Add(";m3u;;pls;"
        ":audio/x-mpegurl");
    MIMETypes->Add(";zip;"
        ":application/x-zip-compressed");
    MIMETypes->Add(";p10;"
        ":application/pkcs10");
    MIMETypes->Add(";cat;"
        ":application/vnd.ms-pki.seccat");
    MIMETypes->Add(";pko;"
        ":application/vnd.ms-pki.pko");
    MIMETypes->Add(";p7r;"
        ":application/x-pkcs7-certreqresp");
    MIMETypes->Add(";p7s;"
        ":application/pkcs7-signature");
    MIMETypes->Add(";exe;"
        ":application/x-msdownload");
    MIMETypes->Add(";crt;;der;;cer;"
        ":application/pkix-cert");
    MIMETypes->Add(";spc;;p7b;"
        ":application/x-pkcs7-certificates");
    MIMETypes->Add(";uls;"
        ":text/iuls");
    MIMETypes->Add(";p7m;;p7c;"
        ":application/pkcs7-mime");
    MIMETypes->Add(";stl;"
        ":application/vnd.ms-pki.stl");
    MIMETypes->Add(";crl;"
        ":application/pkix-crl");
    MIMETypes->Add(";wsc;;sct;"
        ":text/scriptlet");
    MIMETypes->Add(";323;"
        ":text/h323");
    MIMETypes->Add(";rmi;;mid;;midi;"
        ":audio/mid");
    MIMETypes->Add(";vcf;"
        ":text/x-vcard");
    MIMETypes->Add(";cdf;"
        ":application/x-cdf");
    MIMETypes->Add(";sst;"
        ":application/vnd.ms-pki.certstore");
    MIMETypes->Add(";htt;"
        ":text/webviewhtml");
    MIMETypes->Add(";css;"
        ":text/css");
    tzdw = GetTimeZoneInformation(&tzi);
    tzM = tzi.Bias;
    if (tzdw==TIME_ZONE_ID_STANDARD)
        tzM += tzi.StandardBias;
    if (tzdw==TIME_ZONE_ID_DAYLIGHT)
        tzM += tzi.DaylightBias;
    tzh = tzM / 60;  tzm = tzM % 60;
    if (tzM<=0)
        TZinfo.sprintf(" GMT+%02d:%02d", -tzh, -tzm);
    else
        TZinfo.sprintf(" GMT-%02d:%02d", tzh, tzm);
    if (LogSessions)
        log("hServer SESSION STARTED at "+getNow()+TZinfo+"\n");
    /*try
    { TimeZoneBias = EncodeTime((Word)tzh, (Word)tzm, (Word)0, (Word)0); }
    catch (...) { log("Invalid tzh or tzm"); }*/
    IniFileName = ExtractFileDir(ParamStr(0)) + "\\shs.ini";
    IniFileExists = FileExists(IniFileName);
    if (! IniFileExists)
    {
      LoadFromRegistry(); //load in old-vers-style - from registry
      SaveReg(); //save in new-vers-style - to ini file
    }
    else
      LoadReg();  //load in new-vers-style - from ini file
    PreventSaveLangReg=true;
    //DocRootSet();
}
//---------------------------------------------------------------------------


__fastcall TForm1::~TForm1(void)
{
    //TODO: Add your source code here
    delete ParserList;
    //delete FStreams;
//    delete Registry;
    delete MIMETypes;
    delete IPFilters;
    delete CGIAssociations;
    delete RootList;
    if (LogSessions)
    {
        AnsiString tmp;
        tmp.sprintf("Session statistics\n"
            " connects: %d; requests: %d; errors: %d;"
            " attempts to connect from banned IP: %d.",
            SessionTotalConnects, SessionTotalRequests,
            SessionTotalErrors, SessionTotalDeniedIPs);
        log(tmp+"\nhServer SESSION TERMINATED at "+getNow()+"\n");
    }
    if (KillLogOnExit)
      DeleteFile(logFileName);
}//end TForm1::~TForm1
//-----------

void __fastcall TForm1::FormShow(TObject *Sender)
{
    if (HideOnStart)
        Application->Minimize();
    LangComboBox->ItemIndex = Lang;
    LangComboBoxChange(this);
}
//------------------------------

mParser::mParser(void)
{
    //TODO: Add your source code here
    HeadDone = BodyDone = NowLF = false;
    InCGIDir = IsCGI = false;
    BodyLength = BodyPos = HeadPos = 0;
    EnvVarsSize = 0;
    ProcessingRead = false;
    lasttime = Now();
    MustStop = false;  Error = 0;
    Headers = new TStringList();
    Headers->Sorted = false;
    NOpenStreams = 0; CGIType = CGITYPE_DEFAULT;
    Broken = false;
}//end mParser::mParser
//-------

mParser::~mParser(void)
{
    //TODO: Add your source code here
    delete Headers;
}//end mParser::~mParser
//-------

mParserList::mParserList(void)
{
    //TODO: Add your source code here
    list = NULL;  N = 0;
}//end mParserList::mParserList
//-----

mParserList::~mParserList(void)
{
    //TODO: Add your source code here
    int i;
    if (N>0)
    {
        for (i=0; i<N; i++)
            delete list[i];
        free(list);
    }
}//end mParserList::~mParserList
//----

mParser* mParserList::Add(TCustomWinSocket* s)
{
    //TODO: Add your source code here
    mParser* ptr;
    ptr = Get(s);
    if (ptr==NULL)
    {
     list = (mParser**)realloc((void*)list, (N+1)*sizeof(mParser*));
     if (list==NULL)
     {
        Form1->SessionTotalErrors++;
        Form1->log("ERROR: cannot realloc in mParserList::Add");
     }
     else
     {
        ptr = new mParser();
        ptr->sock = s;
        list[N] = ptr;
        N++;
     }
    }
    return ptr;
}//end mParserList::Add
//-------

void mParserList::Remove(TCustomWinSocket* s)
{
    //TODO: Add your source code here
    int i=0;
    bool fnd=false;
    while ((!fnd) && (i<N))
    {
        fnd = (s==list[i]->sock);
        i++;
    }
    if (fnd)
    {
      delete list[i-1];
      while (i<N)
      {
        list[i-1] = list[i];
        i++;
      }
      if (N>1)
        list = (mParser**)realloc((void*)list, (N-1)*sizeof(mParser*));
      else
       {  free(list); list=NULL;  }
      N--;
    }
}//end mParserList::Remove
//-------

mParser* mParserList::Get(TCustomWinSocket* s)
{
    //TODO: Add your source code here
    //mParser* ptr;
    int i=0;
    bool fnd=false;
    while ((!fnd) && (i<N))
    {
        fnd = (s==list[i]->sock);
        i++;
    }
    return (fnd ? list[i-1] : NULL);
}//end mParserList::Get
//--------
//---------------------
void __fastcall TForm1::ServerSocket1ClientConnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
    mParser* p;
    if (UseIPFiltering)
    {
        int i, sllen=IPFilters->Count;
        bool IsWrongIP=false;
        for (i=0; (i<sllen)&&(!IsWrongIP); i++)
            IsWrongIP = TestWrongIP(Socket->RemoteAddress,
                IPFilters->Strings[i]);
        if (IsWrongIP)
        {
            Socket->Close();  SessionTotalDeniedIPs++;
            return;
        }
    }
    p = ParserList->Add(Socket);
    p->IP = Socket->RemoteAddress;
    p->Port.sprintf("%d", Socket->RemotePort);
    SessionTotalConnects++;
    if (LogConnects)
    {
      if (LogRemoteHosts)
        log(p->IP+":"+p->Port+" "+Socket->RemoteHost+" CONNECTED at "+getNow());
      else
        log(p->IP+":"+p->Port+" CONNECTED at "+getNow());
    }
    //Application->MessageBox("connect", "debug", MB_OK);
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ServerSocket1ClientDisconnect(TObject *Sender,
      TCustomWinSocket *Socket)
{
    /*mParser* p;
    p = ParserList->Get(Socket);*/
    AnsiString hostInfo;
    hostInfo = Socket->RemoteAddress;
    hostInfo.sprintf(":%d", Socket->RemotePort);
    if (LogRemoteHosts)
        hostInfo += " "+Socket->RemoteHost;
    if (LogConnects)
    {
        log(hostInfo+" DISCONNECTED at "+getNow()+"\n");
      /*if (p!=NULL)
        log(p->IP+":"+p->Port+" DISCONNECTED at "+getNow()+"\n");
      else
        log("<some host> DISCONNECTED at "+getNow()+"\n");*/
    }
    ParserList->Remove(Socket);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientRead(TObject *Sender,
      TCustomWinSocket *Socket)
{
    mParser* p;
    int len;
    char *Buffer;
    //Application->MessageBox("read1", "debug", MB_OK);
    /*if (! Socket->Connected) return;*/
    //Application->MessageBox("read", "debug", MB_OK);
    p=ParserList->Get(Socket);
    len = Socket->ReceiveLength();
    if (p==NULL)
    {
        p = ParserList->Add(Socket);
        if (len>0)
            log("DEBUG: p==NULL len>0 at "+getNow());
        else
            log("DEBUG: p==NULL len==0 at "+getNow());
        /*Buffer = new char [len];
        Socket->ReceiveBuf((void *)Buffer, len);
        Socket->SendText((AnsiString)errormsg1);
        delete [] Buffer;
        Socket->Close();*/
    }
    if (len>0)
    {
        p->ProcessingRead = true;
        p->lasttime = Now();
        while (len>0)
        {
          if (len>0xffff) len=0xf000;
          Buffer = new char [len];
          len = Socket->ReceiveBuf((void *)Buffer, len);
          if (len>0)
            ParseBuf(p, Buffer, len);
          //Socket->SendText((AnsiString)testmsg1);
          delete [] Buffer;
          len = Socket->ReceiveLength();
        }
        if (p->MustStop)
            Socket->Close();
        p->ProcessingRead = false;
    }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::ServerSocket1ClientError(TObject *Sender,
      TCustomWinSocket *Socket, TErrorEvent ErrorEvent, int &ErrorCode)
{
    AnsiString str;
    /*mParser* p;
    p = ParserList->Get(Socket);*/
    AnsiString hostInfo;
    hostInfo = Socket->RemoteAddress;
    hostInfo.sprintf(":%d", Socket->RemotePort);
    if (LogRemoteHosts)
        hostInfo += " "+Socket->RemoteHost;
    if (ErrorCode!=10054)
    {
        SessionTotalErrors++;
        str.sprintf("code %d", ErrorCode);
        log(hostInfo+" socket ERROR ("+str+") at "+getNow());
    }
    else
    {
        /*p->Broken = true;
        p->lasttime = Now();*/
        if (LogConnects || LogDebug)
        {
          if (LogDebug || (hostInfo[1]!=':'))
            log(hostInfo+" BREAKS connection at "+getNow()+"\n");
        }
    }
    ParserList->Remove(Socket);
    /*try { Socket->Close(); }
    catch (...) { log("cant close socket \n"); } */
    ErrorCode=0;
}
//---------------------------------------------------------------------------


void TForm1::log(AnsiString str)
{
    //TODO: Add your source code here
    int fHandle;
    str+="\n";
    try
    {
        if (FileExists(logFileName))
          fHandle = FileOpen(logFileName,
            fmOpenWrite | fmShareDenyWrite);
        else
          fHandle = FileCreate(logFileName);
        FileSeek(fHandle, 0, 2);
        FileWrite(fHandle, str.c_str(), str.Length());
        FileClose(fHandle);
    }
    catch (...) {}
}//end TForm1::log
//----------------

AnsiString TForm1::getNow(void)
{
    //TODO: Add your source code here
    return DateTimeToStr(Now());
}//end TForm1::getNow
//-----------

void TForm1::ParseBuf(mParser* p, char* buf, int bufLen)
{
    //TODO: Add your source code here
    //if (p->MustStop || (bufLen==0)) return;
    int i=0/*, headpos=0*/;
    bool IsLF=p->NowLF, WasLF, hdWas, b_done=false;
    bool LimitBodySize = !p->IsCGI;
    //log("ParseBuf() started");
    while ((i<bufLen) && (!p->MustStop))
    {
        hdWas = p->HeadDone;
        if (buf[i]!='\r')
        {
            WasLF = IsLF;
            IsLF = (buf[i]=='\n');
            if (!hdWas)
            {
                p->Head.sprintf("%c", buf[i]);
                p->HeadDone = WasLF && IsLF;
                p->HeadPos++;
                if (p->HeadPos>=HEAD_MAX_LEN)
                {
                    p->HeadDone = true; p->BodyDone=true; i = bufLen;
                    p->Error = 413; p->MustStop = true;
                    log(p->IP+":"+p->Port+" overloaded HTTP headers, "
                        "possibly an attack");
                }
                if (p->HeadDone)
                   { ParseHead(p); LimitBodySize = !p->IsCGI; }
            }
        }
        if (p->HeadDone)
        {
            if (p->BodyPos==p->BodyLength)
                p->BodyDone=true;
        }
        if (hdWas && (!p->BodyDone))
        {
            p->Body.sprintf("%c", buf[i]);
            p->BodyPos++;
            if (LimitBodySize && (p->BodyPos>BODY_MAX_LEN))
            { p->BodyPos = p->BodyLength; i = bufLen; }
            if (p->BodyPos==p->BodyLength)
                p->BodyDone=true;
        }
        if (p->BodyDone)
        {
            if (LogFiles)
                log(p->IP+":"+p->Port+" on "+getNow()+" with "+
                    p->HTTPMethod+" requested "+p->URI);
            if (LogDebug)
                log("Local path: "+p->LocalPath);
            if (LogHeaders)
            {
                log(p->IP+":"+p->Port+" Request headers:");
                log(p->Head);
            }
            /*AnsiString BLen;
            BLen.sprintf("BodyLength=%d; length(Body)=%d",
                p->BodyLength, p->Body.Length());
            log(BLen);*/
            DoResponse(p);
            ResetParser(p);
            b_done = true;
        }
        //incrementing
        i++;
        if ((b_done) && (i<bufLen))
        {
            p->NowLF = IsLF;
            ParseBuf(p, buf+i, bufLen-i);
            i = bufLen;
        }
    }//end while
    p->NowLF = IsLF;
}//end TForm1::ParseBuf
//--------------

void TForm1::ResetParser(mParser* p)
{
    //TODO: Add your source code here
    p->Head = ""; p->Body = "";
    p->HeadDone = p->BodyDone = p->NowLF = false;
    p->InCGIDir = p->IsCGI = false;
    p->BodyLength = p->BodyPos = p->HeadPos = 0;
    p->EnvVarsSize = 0;
    p->Error = 0;  p->CGIType = CGITYPE_DEFAULT;
    p->HTTPMethod = ""; p->URI = ""; p->HTTPVersion = "";
    p->LastModif = ""; p->LocalPath = ""; p->QueryString = "";
    p->ExeApp = "";
    p->Headers->Clear();
    SessionTotalRequests++;
}//end TForm1::ResetParser
//-----------

void TForm1::ParseHead(mParser* p)
{
    //TODO: Add your source code here
    bool DoingMethod=true, DoingURI=false, DoingHTTPVersion=false;
    bool DoingName, DoingValue=false/*, MaybeCGI=false*/;
#define MaybeCGI p->InCGIDir
    AnsiString Name, Value, BLen, ExtPathInfo;
//#define fileurl BLen
#define sname BLen
    bool RequestStringDone=false;
    char *buf;
    int i=0, len, pos, cpos;
    bool WasLF, IsLF=false, IsCR, IsSpace;
    bool IsComma, WasComma=false;
    bool RealLF;
    //DWORD tmp;
    bool isdir;
    //log("ParseHead() started\n"+p->Head);
    len = p->Head.Length();
    buf = new char [len+1];
    lstrcpy(buf, p->Head.c_str());
    //get request string
    while (!RequestStringDone)
    {
        IsSpace = (buf[i]==' ');
        IsCR = (buf[i]=='\r');
        IsLF = (buf[i]=='\n');
        IsComma = (buf[i]=='.');
        RequestStringDone = IsLF;
        if (DoingHTTPVersion)
        {
            if (! IsLF)
            {
              if (! IsCR)
                p->HTTPVersion.sprintf("%c", buf[i]);
            }
            else
                DoingHTTPVersion=false;
        }
        if (DoingURI)
        {
            if (! IsSpace)
            {
              if (! (WasComma && IsComma)) //prevent path name attack
                p->URI.sprintf("%c", buf[i]);
            }
            else
              { DoingURI=false; DoingHTTPVersion=true; }
        }
        if (DoingMethod)
        {
            if (! IsSpace)
                p->HTTPMethod.sprintf("%c", buf[i]);
            else
              { DoingMethod=false; DoingURI=true; }
        }
        //increment
        WasComma = IsComma;
        i++;
    }
    //resolve URI to relative
    pos = p->URI.Pos("//");
    if (pos>0)
    {
        pos+=2; p->URI = p->URI.SubString(pos, p->URI.Length()-pos+1);
        pos = p->URI.Pos("/");
        if (pos>0)
           p->URI = p->URI.SubString(pos, p->URI.Length()-pos+1);
        else
           p->URI = "/";
    }
    //check if it in CGI folder
    if (EnableCGI)
        MaybeCGI = CheckCGIDir(p->URI);
    //resolve URI into parts
    cpos = p->URI.Pos(";");
    pos = p->URI.Pos("?");
    if (pos>0)
    {
        if (MaybeCGI)
          p->QueryString = p->URI.SubString(pos+1, p->URI.Length()-pos);
        p->FileURL = p->URI.SubString(1, pos-1);
    }
    else
        p->FileURL = p->URI;
    if ( (cpos>0) && ((pos<=0)||(cpos<pos)) )
    {
        if (MaybeCGI)
        {
          ExtPathInfo = p->FileURL.SubString(cpos+1, pos-cpos-1);
          if (!ExtPathInfo.IsEmpty()) ExtPathInfo=HTTPDecode(ExtPathInfo);
        }
        p->FileURL = p->FileURL.SubString(1, cpos-1);
    }
    p->LocalPath = ResolveToLocal(p->FileURL, MaybeCGI);
    if (MaybeCGI)
    {
      //log("MaybeCGI==true; p->LocalPath=="+p->LocalPath);
 /*     tmp = ::GetFileAttributes(p->LocalPath.c_str());
      isdir = ((tmp & FILE_ATTRIBUTE_DIRECTORY)!=0);       */
      isdir = DirectoryExists(p->LocalPath);
      if (! isdir)
      {
        if (ExtractFileExt(p->LocalPath)=="")
          p->LocalPath += ".exe";
      }
      p->IsCGI = RecognizeCGI(p);
    }
    if (p->IsCGI)
    {//create pseudo-headers for CGI variables
        p->Headers->Add("REQUEST_METHOD");
        p->Headers->Add(p->HTTPMethod);
        p->Headers->Add("QUERY_STRING");
        p->Headers->Add(p->QueryString);
        p->Headers->Add("REMOTE_ADDR");
        p->Headers->Add(p->IP);
        p->Headers->Add("REMOTE_PORT");
        p->Headers->Add(p->Port);
        p->Headers->Add("SCRIPT_NAME");
        p->Headers->Add(p->FileURL);
        p->Headers->Add("GATEWAY_INTERFACE");
        p->Headers->Add("CGI\/1.1");
        p->Headers->Add("SERVER_SOFTWARE");
        p->Headers->Add("Son_hServer\/"+AboutBox->ProgVersion);
        p->Headers->Add("SERVER_PROTOCOL");
        p->Headers->Add(p->HTTPVersion);
        p->Headers->Add("SERVER_PORT");
        p->Headers->Add(p->sock->LocalPort);
        p->Headers->Add("SCRIPT_FILENAME"); //non-standard, for PHP
        p->Headers->Add(p->LocalPath);
        sname = p->sock->LocalHost;
        if (sname.IsEmpty()) sname = p->sock->LocalAddress;
        else
        {
            pos = sname.Pos("\/\/");
            if (pos>0)
                sname = sname.SubString(pos+2, sname.Length()-pos-1);
        }
        p->Headers->Add("SERVER_NAME");
        p->Headers->Add(sname);
        if (!ExtPathInfo.IsEmpty())
        {
          p->Headers->Add("PATH_INFO");
          p->Headers->Add(ExtPathInfo);
          p->Headers->Add("PATH_TRANSLATED");
          p->Headers->Add(ResolveExtra(ExtPathInfo, p));
        }
        if (DuplicateIPInVar)
        {
            p->Headers->Add(DuplicateIPVar); //e.g. HTTP_X_FORWARDED_FOR
            p->Headers->Add(p->IP);
        }
        p->EnvVarsSize = p->Headers->Count;
    }
    //get header variables
    DoingName = true;
    while (i<len)
    {
        WasLF = IsLF;
        IsCR = (buf[i]=='\r');
        IsLF = (buf[i]=='\n');
        IsSpace = (buf[i]==' ');
        if (! (DoingName | DoingValue))
        {
            DoingValue = ! IsSpace;
        }
        RealLF = WasLF && (! IsSpace);
        if (RealLF)
        {
            if (! Name.IsEmpty())
             { p->Headers->Add(Name); p->Headers->Add(Value); }
            Name = ""; Value = "";
            DoingName=true; DoingValue=false;
        }
        if (DoingName)
        {
            if (buf[i]!=':')
                Name.sprintf("%c", buf[i]);
            else
                DoingName = false;
        }
        if (DoingValue && (! IsLF) && (! IsCR))
        {
            Value.sprintf("%c", buf[i]);
        }
        //increment
        i++;
    }
    delete [] buf;
    BLen = getHTTPHeader(p, "Content-Length");
    if (! BLen.IsEmpty())
    {
      try
      {
        p->BodyLength = BLen.ToInt();
      }
      catch (...)
      {
        p->BodyLength = 0;  p->MustStop = true;  p->Error = 400;
      }
    }
    p->HTTPMinorV = ExtractHTTPVersion(p->HTTPVersion);
    if (p->HTTPMethod.Length()>20) //anti-DoS
    {
        p->HTTPMethod = "UNKNOWN"; //to detect DoS attack
        p->MustStop = true;
    }
#undef sname
//#undef fileurl
#undef MaybeCGI
}//end TForm1::ParseHead
//-------------

void TForm1::DoResponse(mParser* p)
{
    //TODO: Add your source code here
#define RESPERR_NO  0
#define RESPERR_NOT_FOUND  1
#define RESPERR_ACCESS_DENIED  2
#define RESPERR_INTERNAL_ERROR  3
#define LocalPath p->LocalPath
    AnsiString ResponceString, ResponceHead, ResponceBody;
    AnsiString CType, OtherHeaders, RedirURI;
    int ResponceBodyLength, ResponceType=RESPONCE_TEXT;
    int TheResponceError=RESPERR_NO;
    DWORD tmp;
    FILETIME lastmt;
    THandleStream* fs;
    bool RequestProcessed=false;
    char *ResponceMsg=(p->Error==0) ? "OK" : "Error";
    CType = "text/html";
    // test
    /*for (int i=0; i<p->Headers->Count; i++)
        ResponceBody += p->Headers->Strings[i]+"\n"; */
    if ((p->HTTPMinorV<0) || (p->HTTPMinorV>1))
    {//if incorrect HTTP version
        if (p->HTTPMinorV<0)
        {
            p->MustStop = true;  p->Error = 400;
            ResponceMsg = "Bad HTTP version in request";
        }
        else
        {
            p->Error = 505;  ResponceBody = "WRONG PROTOCOL VERSION\n"
                "Server supports only HTTP/1.1 and earlier";
            ResponceMsg = "Too big HTTP version in request";
        }
        log(p->IP+":"+p->Port+" incorrect protocol "+p->HTTPVersion);
    }//end if
    else
    {//if correct HTTP v.
      if ((!p->IsCGI)&&(p->BodyLength>BODY_MAX_LEN))
      {
        p->MustStop = true;  p->Error = 413;
        ResponceMsg = "Too big request entity";
        RequestProcessed=true;
      }
      if (DenieNonprogramsInCGI && p->InCGIDir && (!p->IsCGI))
      {
        TheResponceError = RESPERR_NOT_FOUND;
        RequestProcessed=true;
      }
      if ( (!RequestProcessed)&&((p->HTTPMethod=="GET")||
          (p->HTTPMethod=="HEAD")||(p->HTTPMethod=="POST")) )
      {
        //LocalPath = ResolveToLocal(p->URI);
        if ( CheckFilename(LocalPath) &&
            (FileExists(LocalPath) || DirectoryExists(LocalPath)) )
        {
            tmp = ::GetFileAttributes(LocalPath.c_str());
        }
        else
            tmp = 0xFFFFFFFF;
        if (tmp==0xFFFFFFFF)
        {
            TheResponceError = RESPERR_NOT_FOUND;
            RequestProcessed=true;  p->IsCGI=false;
        }
        else
        {
          if (tmp & (FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM))
          {
            TheResponceError = RESPERR_ACCESS_DENIED;
            RequestProcessed=true;  p->IsCGI=false;
          }
          if (tmp & (FILE_ATTRIBUTE_OFFLINE | FILE_ATTRIBUTE_TEMPORARY))
          {
            ResponceBody = p->URI + "<br><br>Resource is inaccessible.";
            TheResponceError = RESPERR_ACCESS_DENIED;
            RequestProcessed=true;  p->IsCGI=false;
          }
          if (tmp & FILE_ATTRIBUTE_DIRECTORY)
          {
            if (p->FileURL[p->FileURL.Length()]!='\/')
            {
              ResponceType=RESPONCE_REDIR;
              RedirURI = (AnsiString)"http://"+
                getHTTPHeader(p, "Host")+p->URI+"/";
              OtherHeaders += (AnsiString)"Location: "+
                RedirURI+"\n";
              p->Error = 301; ResponceMsg = "Redirect";
              CType = "text/html";
              ResponceBody = (AnsiString)"<html><head>"
                "<title>Redirect</title>"
                "</head><body>Redirecting to <a href=\'"+
                RedirURI+"\'>"+RedirURI+"</a></body></html>";
              RequestProcessed=true;  p->IsCGI=false;
            }
            else
            {
              if (FindCatalogIndex(LocalPath))
              {
                p->IsCGI = RecognizeCGI(p); // ======= ATTENTION!!! =======
                RequestProcessed=false; //let it be the index file
              }
              else
              {
                if (ShowCatalogContents && (!p->InCGIDir))
                {
                    ResponceBody = GetCatalogContents(LocalPath);
                    CType = "text/html";
                }
                else
                {
                    ResponceBody = p->URI + "<br>"
                        "doesn`t have an index.";
                    TheResponceError = RESPERR_ACCESS_DENIED;    
                }
                RequestProcessed=true;
              }
            }
          }//end if (tmp & FILE_ATTRIBUTE_DIRECTORY)
        }//end else
        if (p->IsCGI && (p->HTTPMethod=="HEAD"))
           { RequestProcessed=true;  p->IsCGI=false; }
        if (!RequestProcessed)
        {
          if (p->IsCGI)
          {//for CGI apps
            //bool cgi_ok;
            int fhndl;
            fhndl = RunCGI(p, ResponceBodyLength/*, cgi_ok*/);
            if (ResponceBodyLength<0)
            {
                p->Error = 500; ResponceMsg="Error running CGI script";
                ResponceType = RESPONCE_TEXT;  p->IsCGI = false;
            }
            else
            {
              try
              {
                fs = new mAutocloseStream(fhndl);
              }
              catch (...)
              {
                fs = NULL;
                SessionTotalErrors++;
                log(p->IP+":"+p->Port+
                  " ERROR init-ing mAutocloseStream. CGI app: "+LocalPath);
              }
              if (fs!=NULL)
              {
                ResponceType = RESPONCE_FILE;
                if (p->Error == 301)
                  ResponceMsg = "Redirect";
                //debug
                /*log("fs!=NULL");  */
              }
              else
              {
                ResponceType = RESPONCE_TEXT;  p->IsCGI=false;
                TheResponceError = RESPERR_INTERNAL_ERROR;
                log("fs==NULL");
              }
              RequestProcessed=true;
            }
          }
          else
          {//for non-CGI files
            try
            {
                fs = new TFileStream(LocalPath,
                  fmOpenRead | fmShareDenyWrite);
            }
            catch (...)
            {
                fs = NULL;
                SessionTotalErrors++;
                log(p->IP+":"+p->Port+
                  " ERROR: cant open requested file: "+LocalPath);
            }
            if (fs!=NULL)
            {
                if (::GetFileTime((HANDLE)fs->Handle,
                    NULL, NULL, &lastmt))
                  p->LastModif = GenHTTPDate(lastmt);
                ResponceType = RESPONCE_FILE;
                CType = GetMIMEType(LocalPath);
            }
            else
            {
                ResponceType = RESPONCE_TEXT;
                TheResponceError = RESPERR_INTERNAL_ERROR;
            }
            RequestProcessed=true;
          }
        }//end if (!RequestProcessed)
      }//end if ((p->HTTPMethod=="GET")||(p->HTTPMethod=="HEAD"))
      else
      {
        if (!RequestProcessed)
        {
          if (p->HTTPMethod=="OPTIONS")
          {
            OtherHeaders = "Allow: OPTIONS, HEAD, GET, POST\n";
          }//end if
          else
          {
            if (/*(p->HTTPMethod=="POST") || */(p->HTTPMethod=="PUT") ||
                (p->HTTPMethod=="DELETE") || (p->HTTPMethod=="TRACE") ||
                (p->HTTPMethod=="CONNECT"))
            {
                p->Error = 405; ResponceMsg = "Method not supported";
                OtherHeaders = "Allow: OPTIONS, HEAD, GET, POST\n";
                ResponceBody = "SORRY. Method \'"+p->HTTPMethod+
                    "\' is not supported by the server.";
            }//end if
            else
            {
                p->Error = 501; ResponceMsg = "Unknown method";
            }//end else
          }//end else (p->HTTPMethod=="OPTIONS")
        }//end if (!RequestProcessed)
      }//end else ((p->HTTPMethod=="GET")||(p->HTTPMethod=="HEAD"))
    }//end if correct HTTP v.
    if (TheResponceError!=RESPERR_NO)
    {
        if (AllErrorsAsStatusCodes)
        {
            if ((! Use403) && (TheResponceError==RESPERR_ACCESS_DENIED))
              TheResponceError = RESPERR_NOT_FOUND;
            switch(TheResponceError)
            {
            case RESPERR_NOT_FOUND:
                p->Error = 404; ResponceMsg = "Not found";
                if (!ErrorFile404.IsEmpty())
                {
                  if (IsItURL(ErrorFile404))
                  {
                    OtherHeaders += (AnsiString)"Location: "+
                      ErrorFile404+"\n";
                    p->Error = 301;
                  }
                  else
                  {
                    if (FileExists(ErrorFile404))
                      ResponceBody = LoadAstr(ErrorFile404);
                  }
                }//end if
                else
                  ResponceBody = "<h1>Not Found</h1>";
            break;
            case RESPERR_ACCESS_DENIED:
                p->Error = 403; ResponceMsg = "Access denied";
                if (!ErrorFile403.IsEmpty())
                {
                  if (IsItURL(ErrorFile403))
                  {
                    OtherHeaders += (AnsiString)"Location: "+
                      ErrorFile403+"\n";
                    p->Error = 301;
                  }
                  else
                  {
                    if (FileExists(ErrorFile403))
                      ResponceBody = LoadAstr(ErrorFile403);
                  }
                }//end if
                else
                  ResponceBody = "<h1>Access Denied</h1>\n"+ResponceBody;
            break;
            default:
                p->Error = 500; ResponceMsg = "Internal server error";
                if (!ErrorFile500.IsEmpty())
                {
                  if (IsItURL(ErrorFile500))
                  {
                    OtherHeaders += (AnsiString)"Location: "+
                      ErrorFile500+"\n";
                    p->Error = 301;
                  }
                  else
                  {
                    if (FileExists(ErrorFile500))
                      ResponceBody = LoadAstr(ErrorFile500);
                  }
                }//end if
                else
                  ResponceBody = "<h1>Internal Server Error</h1>";
            }
        }
        else
        {
            switch(TheResponceError)
            {
            case RESPERR_NOT_FOUND:
              ResponceBody = p->URI + "\n"
                "SORRY.\n\nThe resource with given name"
                " doesnt exist.";
            break;
            case RESPERR_ACCESS_DENIED:
                if (ResponceBody.IsEmpty())
                  ResponceBody = p->URI + "\nSORRY.\n\nAccess to"
                    " requested resource is denied.";
            break;
            default:
              ResponceBody = "INTERNAL SERVER ERROR";
            }
        }
    }//end if (TheResponceError!=RESPERR_NO)
    if (getHTTPHeader(p, "Connection")=="close")
    {
        p->MustStop = true;
    }
    if (! p->LastModif.IsEmpty())
        OtherHeaders += (AnsiString)"Last-Modified: "+
             p->LastModif+"\n";
    if (p->HTTPMinorV<1) //HTTP/1.0
    {
      if (getHTTPHeader(p, "Connection")!="keep-alive")
        p->MustStop = true;
      ResponceString.sprintf("HTTP/1.0 %d %s\n",
        (p->Error==0) ? 200 : p->Error, ResponceMsg);
    }
    else //HTTP/1.1
    {
      if (p->MustStop)
        OtherHeaders += "Connection: close\n";
      ResponceString.sprintf("HTTP/1.1 %d %s\n",
        (p->Error==0) ? 200 : p->Error, ResponceMsg);
    }
    if (SendServerHeader)
        OtherHeaders += "Server: Son_hServer\/"+
            AboutBox->ProgVersion+"\n";
    //headers
    if ((ResponceType==RESPONCE_TEXT)||(ResponceType==RESPONCE_REDIR))
        ResponceBodyLength = ResponceBody.Length();
    if ((ResponceType==RESPONCE_FILE)&&(!p->IsCGI))
        ResponceBodyLength = fs->Size;
    if (p->IsCGI && (ResponceType==RESPONCE_FILE))
    {
      log("p->IsCGI && (ResponceType==RESPONCE_FILE)");
      ResponceHead.sprintf("Content-Length: %d\n%s",
        ResponceBodyLength, OtherHeaders.c_str());
    }
    else
    {
      if (ResponceBodyLength>0)
        ResponceHead.sprintf("Content-Type: %s\n%s"
          "Content-Length: %d\n\n", CType.c_str(),
          OtherHeaders.c_str(), ResponceBodyLength);
      else
        ResponceHead.sprintf("%sContent-Length: %d\n\n",
          OtherHeaders.c_str(), ResponceBodyLength);
    }
    //log("debug: ResponceHead\n"+ResponceHead);
    //send
    if ((p->HTTPMethod=="GET")||(p->HTTPMethod=="POST"))
    {
      if (ResponceType==RESPONCE_TEXT)
        p->sock->SendText(ResponceString+ResponceHead+ResponceBody);
      if (ResponceType==RESPONCE_FILE)
      {
        p->sock->SendText(ResponceString+ResponceHead);
        log("ResponceString=="+ResponceString+"\nResponceHead=="+ResponceHead);
        p->sock->SendStream(fs);
        //log("SendStream executed");
      }
      if (ResponceType==RESPONCE_REDIR)
        p->sock->SendText(ResponceString+ResponceHead+ResponceBody);
    }//end if
    else
    {
      p->sock->SendText(ResponceString+ResponceHead);
      if (ResponceType==RESPONCE_FILE)
        delete fs;
      else
      {
        if (p->HTTPMethod!="HEAD")
            p->sock->SendText(ResponceBody);
      }
    }//end else
#undef LocalPath
#undef RESPERR_NO
#undef RESPERR_NOT_FOUND
#undef RESPERR_ACCESS_DENIED
#undef RESPERR_INTERNAL_ERROR
}//end TForm1::DoResponse
//--------------

AnsiString TForm1::getHTTPHeader(mParser* p, AnsiString name)
{
    //TODO: Add your source code here
    AnsiString value;
    int ni, len;
    len = p->Headers->Count;  ni = 0;
    while (ni<len)
    {
        if (name.AnsiCompareIC(p->Headers->Strings[ni])==0)
            value = p->Headers->Strings[ni+1].LowerCase();
        //add 2
        ni+=2;
    }
    //result
    return value;
}//end TForm1::getHTTPHeader
//-----------

AnsiString TForm1::ResolveToLocal(AnsiString uri, bool in_cgidir)
{
    //TODO: Add your source code here
    AnsiString ret, escapeBuf;
    int i, len, hibyte, lowbyte, sstmp, escapeVal;
    unsigned char c, *ptr;
    if (in_cgidir && UseSepCGIFolder)
    {
        i = CGIDir.Length();
        if (i<=0)
        {
            log("ATTENTION! CGI dir is incorrect! Please "
                "do not play with registry.\nGo to Options dialog "
                "on CGI tab and change \'CGI dir\' to correct one.");
            i=1;
        }
        uri = uri.SubString(i, uri.Length()-i+1);
        ret = SeparateCGIFolder;
    }
    else
        ret = RootCatalog;
    len = uri.Length();
    ptr = (unsigned char*)uri.c_str();
    if (ptr[0]!='\/') ret += "\\";
    for (i=0; i<len; i++)
    {
        c = ptr[i];
        switch (c)
        {
        case '/': c = '\\'; break;
        case '*': c = '\\'; break;
        case '%'://escape sequences
            if (len-i<3)
                c='%';
            else
            {//parsing hi-byte sequence
              escapeBuf = uri.SubString(i+2,2);
              try { sstmp=sscanf(escapeBuf.c_str(), "%x", &hibyte); }
              catch(...) { sstmp=0; }
              if (sstmp!=1) c='%';
              else
              {
                i+=2;
                if ((hibyte==0x20) || (len-i<4)) c=' '; //space
                else
                {
                    i++;
                    //parsing low-byte sequence
                    escapeBuf = uri.SubString(i+2,2);
                    try { sstmp=sscanf(escapeBuf.c_str(), "%x", &lowbyte); }
                    catch(...) { sstmp=0; }
                    if (sstmp!=1) c='%';
                    else
                    {
                      i+=2;
                      //map escape number into win-1251 character
                      escapeVal = (hibyte<<8) | lowbyte;
                      if ((escapeVal>=0xD090) && (escapeVal<=0xD0AF))
                      {
                        c = (unsigned char)(escapeVal-0xD090+192);
                      }//-
                      if ((escapeVal>=0xD0B0) && (escapeVal<=0xD0BF))
                      {
                        c = (unsigned char)(escapeVal-0xD0B0+224);
                      }//-
                      if ((escapeVal>=0xD180) && (escapeVal<=0xD18F))
                      {
                        c = (unsigned char)(escapeVal-0xD180+240);
                      }//-
                      if (escapeVal==0xD081)
                        c = 168; //
                      if (escapeVal==0xD191)
                        c = 184; //
                    }//end else
                }//end else
              }//end else
            }//end else
        break;
        }
        if ((i<len-1) || (c!='\\'))
            ret.sprintf("%c", c);
    }//end for
    return ret;
}//end TForm1::ResolveToLocal
//---------

AnsiString TForm1::GetCatalogContents(AnsiString path)
{
    //TODO: Add your source code here
    AnsiString ret, fmask, fname, fsz, linkuri;
    HANDLE h;
    WIN32_FIND_DATA fdata;
    BOOL fndnext;
    bool Loop=true;
    //Begin HTML
    if (IndexCssURL.IsEmpty())
     ret = "<html><head><title>Catalog contents</title>"
        "<style type=\"text/css\">\ntd, th {text-align:center}\n"
        "td.fname {font-family:monospace}\n"
        "td.fsize {letter-spacing:2px; font-size:8pt}\n</style>"
        "</head><body>\n";
    else
     ret = "<html><head><title>Catalog contents</title>\n"
        "<link rel=\"stylesheet\" type=\"text/css\" href=\""+
        IndexCssURL+"\">\n</head><body>\n";
    //Begin table
    ret += "<h1>THE CATALOG</h1>\n"
        "<table width=100%><thead><th>File<th>Size</thead>\n";
    fmask = path+"\\*";
    h = FindFirstFile(fmask.c_str(), &fdata);
    if (h==INVALID_HANDLE_VALUE)
      ret += "<tr><td colspan=\"*\"><i>empty catalog</i></tr>";
    else
    {
      while (Loop)
      {
        fname = fdata.cFileName;
        //if (fname==".") fname="";
        linkuri = ResolveToURI(path,fname);
        if (fdata.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
         { fsz = "/CATALOG/"; linkuri += "/"; }
        else
        {
            fsz = "";
            if (fdata.nFileSizeHigh!=0)
                fsz.sprintf("%lu * 2^32 + ", fdata.nFileSizeHigh);
            fsz.sprintf("%lu", fdata.nFileSizeLow);
        }//end else
        if ( ! (fdata.dwFileAttributes &
               (FILE_ATTRIBUTE_HIDDEN | FILE_ATTRIBUTE_SYSTEM)) )
        {
          if ( ! ( (fname==".") || (!CheckFilename(fname)) ||
                   ((fname=="..")&&(path==RootCatalog)) ) )
           ret += (AnsiString)"<tr><td class=\"fname\"><a href=\""+
            linkuri+"\">"+fname+
            "</a><td class=\"fsize\">"+fsz+"</tr>\n";
        }
        fndnext = FindNextFile(h, &fdata);
        Loop = (fndnext!=0);
      }//end while
      FindClose(h);
    }//end else
    //End table
    ret += "</table>\n";
    //End HTML
    ret += "</body></html>";
    return ret;
}//end TForm1::GetCatalogContents
//--------

AnsiString TForm1::ResolveToURI(AnsiString path, AnsiString f)
{
    //TODO: Add your source code here
    AnsiString ret, escapeBuf, fpath;
    int i, len, escapeVal, evh, evl, rootpos;
    unsigned char c, *ptr;
    fpath = path + "\\" + f;
    rootpos = fpath.Pos(RootCatalog);
    if (rootpos!=-1)
        fpath.Delete(1, RootCatalog.Length());
    else
    {
        ret = "/ERROR/";
        log("ERROR: "+fpath+" doesnt contain root path");
    }
    len = fpath.Length();
    ptr = (unsigned char*)fpath.c_str();
    for (i=0; i<len; i++)
    {
        c = ptr[i];
        if (c == '\\') c = '/';
        if ((c < 128) && (c!=' ')) ret.sprintf("%c", c); //ascii
        else
        {
          if (c == ' ')
            ret.sprintf("%%20");
          else
          {//escaping russian
            escapeVal = 0xD081; // by default :)
            if ((c >= 192) && (c <= 223)) //-
                escapeVal = 0xD090 + (c - 192);
            if ((c >= 224) && (c <= 239)) //-
                escapeVal = 0xD0B0 + (c - 224);
            if (c >= 240) //-
                escapeVal = 0xD180 + (c - 240);
            if (c == 184) //
                escapeVal = 0xD191;
            evh = (escapeVal & 0xff00)>>8;
            evl = escapeVal & 0xff;
            ret.sprintf("%%%X%%%X", evh, evl);
          }//end else
        }//end else
    }//end for
    return ret;
}//end TForm1::ResolveToURI
//------

mFileStreams::mFileStreams(void)
{
    list = NULL; plist = NULL; N=0;
}//end mFileStreams::mFileStreams
//----------

mFileStreams::~mFileStreams(void)
{
    int i;
    if (N>0)
    {
        for (i=0; i<N; i++)
        {
            try { delete list[i]; }
            catch (...) {}
        }
        free(list);
        free(plist);
    }
}//end mFileStreams::~mFileStreams
//----------

TFileStream* mFileStreams::Add(AnsiString fnm, mParser* p)
{
    TFileStream* ret;
    try
    {
      ret = new TFileStream(fnm, fmOpenRead | fmShareDenyWrite);
    }
    catch (...)
    {
        try { delete ret; } catch (...) {}
        ret = NULL;
    }
    if (ret!=NULL)
    {
        void *ptr, *pptr;
        ptr = realloc((void*)list, (N+1)*sizeof(TFileStream*));
        pptr = realloc((void*)plist, (N+1)*sizeof(mParser*));
        if ((ptr!=NULL)&&(pptr!=NULL))
        {
            list = (TFileStream**)ptr;  plist = (mParser**)pptr;
            list[N] = ret;  plist[N] = p;
            p->NOpenStreams++;
            N++;
        }
        else
        {
            try { delete ret; } catch (...) {}
            ret = NULL;
            Form1->log(Form1->getNow()+" couldnt realloc in "
                "mFileStreams::Add\n the file is "+fnm+"\n"
                " the IP:port are "+p->IP+":"+p->Port);
        }
    }
    return ret;
}//end mFileStreams::Add
//------------

void mFileStreams::Delete(int num)
{
    if (num>=N) return;
    int i;
    mParser* p;
    p = plist[num];
    /*try { delete list[num]; }
    catch (...)
    {
        Form1->log(Form1->getNow()+" couldnt delete in "
          "mFileStreams::Delete\n the IP is "+p->IP);
    } */
    /*p->sock->SendText("");*/
    p->NOpenStreams--;
    for (i=num+1; i<N; i++)
    {
        list[i-1] = list[i];  plist[i-1] = plist[i];
    }
    list = (TFileStream**)realloc((void*)list,
        (N-1)*sizeof(TFileStream*));
    plist = (mParser**)realloc((void*)plist, (N-1)*sizeof(mParser*));
    N--;
}//end mFileStreams::Delete
//----------------

void mFileStreams::Refresh(void)
{
    bool NoneFound, OneFound;
    int i;
    do
    {
        NoneFound=true; OneFound=false;
        i=0;
        while ((!OneFound)&&(i<N))
        {
            try
            {
              OneFound = (list[i]->Position >= list[i]->Size);
            }
            catch (...)
            { OneFound=true; }
            if (OneFound)
            {
                Delete(i);
                NoneFound = false;
            }
            i++;
        }
    } while (!NoneFound);
}//end mFileStreams::Refresh
//-------------
void __fastcall TForm1::Timer1Timer(TObject *Sender)
{
    //FStreams->Refresh();
    if (ShowRuntimeStatistics)
    {
        char *fmtstr="error", *fmtstr2="error";
        AnsiString tmp;
        switch (Lang)
        {
        case 0: //Ru
            fmtstr = ":  - %d;  - %d;  - %d";
            fmtstr2 = "  - %d\n"
              "    IP - %d";
        break;
        case 2: //By
            fmtstr = ":  - %d;  - %d;  - %d";
            fmtstr2 = "  - %d\n"
              "    IP - %d";
        break;
        case 3: //Srb
            fmtstr = ":  - %d;  - %d;  - %d";
            fmtstr2 = "  - %d\n"
              "     - %d";
        break;
        case 4: //Ua
            fmtstr = ": ' - %d;  - %d;  - %d";
            fmtstr2 = "  - %d\n"
              " '   IP - %d";
        break;
        case 5: //Bg
            fmtstr = ":  - %d;  - %d;  - %d";
            fmtstr2 = "  - %d\n"
              "     IP - %d";
        break;
        default: //En
            fmtstr = "Total: connects - %d; requests - %d; errors - %d";
            fmtstr2 = "active connections - %d\n"
              "connect attempts from banned IPs - %d";
        }
        tmp.sprintf(fmtstr, SessionTotalConnects, SessionTotalRequests,
            SessionTotalErrors);
        StatLabel1->Caption = tmp;
        tmp = "";  tmp.sprintf(fmtstr2,
            ParserList->N, SessionTotalDeniedIPs);
        StatLabel2->Caption = tmp;
    }//end if
    IndicatorShape->Brush->Color = (ParserList->N > 0) ?
      clLime : clBlack;
}//end TForm1::Timer1Timer
//---------------------------------------------------------------------------


AnsiString __fastcall TForm1::GetMIMEType(AnsiString fname)
{
    //TODO: Add your source code here
    AnsiString ext, ret, curitem;
    int i, L, mtypeind;
    ext = ExtractFileExt(fname);
    ext = (AnsiString)";"+ext.SubString(2, ext.Length()-1)+";";
    //log(ext);
    L = MIMETypes->Count;
    for (i=0; (i<L)&&(ret.IsEmpty()); i++)
    {
        curitem = MIMETypes->Strings[i];
        if (curitem.Pos(ext)!=0)
        {
            mtypeind = curitem.Pos(":");
            ret = curitem.SubString(mtypeind+1,
                curitem.Length()-mtypeind);
            //log(ret);
        }
    }//end for
    if (ret.IsEmpty())
        ret = "application/octet-stream";
    return ret;
}//end TForm1::GetMIMEType
//---------

bool TForm1::FindCatalogIndex(AnsiString& path)
{
    //TODO: Add your source code here
    AnsiString fmask;
    HANDLE h;
    WIN32_FIND_DATA fdata;
    bool ret=false;
    fmask = path+"\\index.*htm*";
    h = FindFirstFile(fmask.c_str(), &fdata);
    if (h==INVALID_HANDLE_VALUE)
        ret=false;
    else
    {
        ret=true;
        path=path+"\\"+fdata.cFileName;
        FindClose(h);
    }
    if (ret) return true; //if *htm* found - return
    //now finding php*
    ret=false;
    fmask = path+"\\index.php*";
    h = FindFirstFile(fmask.c_str(), &fdata);
    if (h==INVALID_HANDLE_VALUE)
        ret=false;
    else
    {
        ret=true;
        path=path+"\\"+fdata.cFileName;
        FindClose(h);
    }
    if (ret) return true; //if php* found - return
    //now finding cgi*
    ret=false;
    fmask = path+"\\index.cgi*";
    h = FindFirstFile(fmask.c_str(), &fdata);
    if (h==INVALID_HANDLE_VALUE)
        ret=false;
    else
    {
        ret=true;
        path=path+"\\"+fdata.cFileName;
        FindClose(h);
    }
    if (ret) return true; //if cgi* found - return
    //now finding pl*
    ret=false;
    fmask = path+"\\index.pl*";
    h = FindFirstFile(fmask.c_str(), &fdata);
    if (h==INVALID_HANDLE_VALUE)
        ret=false;
    else
    {
        ret=true;
        path=path+"\\"+fdata.cFileName;
        FindClose(h);
    }
    return ret;
}//end TForm1::FindCatalogIndex
//--------------
void __fastcall TForm1::LangComboBoxChange(TObject *Sender)
{
    AnsiString the_year;
    the_year=", 2003 - 2023";
    Lang = LangComboBox->ItemIndex;
    switch (Lang)
    {
    case 0: //Ru
        OptionsButton->Caption = "...";
        AboutBtn->Hint = "  Son hServer";
        HideButton->Caption = "";
        Label2->Caption = ":";
        Restore->Caption = "";
        Exit->Caption = "";
        OptionsForm->Caption = " ";
        OptionsForm->TabSheet1->Caption = "";
        OptionsForm->TabSheet2->Caption = "";
        OptionsForm->OKButton->Caption = "";
        OptionsForm->CancelButton->Caption = "";
        OptionsForm->Label1->Caption = "  :";
        OptionsForm->Label3->Caption = " :";
        OptionsForm->Language->Items->Strings[0] = "";
        OptionsForm->Language->Items->Strings[1] = "";
        OptionsForm->Language->Items->Strings[2] = "";
        OptionsForm->Language->Items->Strings[3] = "";
        OptionsForm->Language->Items->Strings[4] = "";
        OptionsForm->Language->Items->Strings[5] = "";
        OptionsForm->ShowStatCheckBox->Caption =
            "   ";
        OptionsForm->ShowCatContCheckBox->Caption =
            "     -";
        OptionsForm->HideOnStartCheckBox->Caption =
            "     ";
        OptionsForm->Label2->Caption =
            "  -  :";
        OptionsForm->LogSessionsCheckBox->Caption = "";
        OptionsForm->LogConnectsCheckBox->Caption = "";
        OptionsForm->LogFilesCheckBox->Caption =
            "  ()";
        OptionsForm->LogHeadersCheckBox->Caption =
            "  ";
        AboutBox->Caption = " ";
        AboutBox->OKButton->Caption = "";
        AboutBox->Label2->Caption =
            "       -";
        AboutBox->Version->Caption = " "+AboutBox->ProgVersion;
        AboutBox->Author->Caption =
            "  "+the_year;
        AboutBox->Label3->Caption = "WWW  :";
        AboutBox->Label4->Caption = " E-MAIL:";
        AboutBox->Freeware->Caption =
            "  - FREEWARE.   "
            "( ) . "
            "   -  "
            " .    "
            "      "
            "e-mail  WWW .";
   //     AboutBox->Adv->Caption = "( [ ]    )";
        AboutBox->MyForum->Caption = " ";
        OptionsForm->LogDebugCheckBox->Caption =
            "( )";
        OptionsForm->LogRemoteHostsCheckBox->Caption =
            " ";
        OptionsForm->TabSheet3->Caption = " IP";
        OptionsForm->UseIPFilteringCheckBox->Caption =
            "     IP:";
        OptionsForm->IPFilterAdd->Caption =
            "  IP";
        OptionsForm->IPFilterEdit->Caption =
            "  IP";
        OptionsForm->IPFilterRemove->Caption =
            "  IP";
        OptionsForm->IPFiltersClear->Caption =
            " ";
        OptionsForm->SendServerHeaderCheckBox->Caption =
            " HTTP- \"Server:\"";
        OptionsForm->Label4->Caption =
            "URL   (CSS)  -:";
        OptionsForm->ECGICheckBox->Caption =
            " CGI";
        OptionsForm->Label5->Caption =
            " CGI:";
        OptionsForm->RestoreDefCGIDirButton->Caption =
            "<-   ";
        OptionsForm->USCGIFCheckBox->Caption =
            "    CGI :";
        OptionsForm->DNICGICheckBox->Caption =
            "   -   CGI";
        OptionsForm->TabSheet5->Caption = "";
        OptionsForm->DPAFCheckBox->Caption =
            ",     , "
            " (  UNIX)";
        OptionsForm->AEASCCheckBox->Caption =
            "   HTTP  -";
        OptionsForm->DIPIVCheckBox->Caption =
            " IP   CGI  :";
        OptionsForm->CGIAssocGroupBox->Caption =
            " CGI-";
        OptionsForm->CGIAssocAdd->Caption =
            " ";
        OptionsForm->CGIAssocEdit->Caption =
            " ";
        OptionsForm->CGIAssocRemove->Caption =
            " ";
        OptionsForm->CGIAssocClear->Caption =
            " ";
        OptionsForm->AddRootButton->Hint =
            "    ";
        OptionsForm->RemoveRootButton->Hint =
            "   ";
        OptionsForm->ErrFilesLabel->Caption =
            "   (   URL):";
        OptionsForm->KLOECheckBox->Caption =
            " -   -";
        AboutBox->Star->Hint = " ";
        AboutBox->Sun->Hint = " ";
    break;
    case 2: //
        OptionsButton->Caption = "...";
        AboutBtn->Hint = "  Son hServer";
        HideButton->Caption = "";
        Label2->Caption = ":";
        Restore->Caption = "";
        Exit->Caption = "";
        OptionsForm->Caption = " ";
        OptionsForm->TabSheet1->Caption = "";
        OptionsForm->TabSheet2->Caption = "";
        OptionsForm->OKButton->Caption = "";
        OptionsForm->CancelButton->Caption = "";
        OptionsForm->Label1->Caption = "  :";
        OptionsForm->Label3->Caption = " :";
        OptionsForm->Language->Items->Strings[0] = "";
        OptionsForm->Language->Items->Strings[1] = "";
        OptionsForm->Language->Items->Strings[2] = "";
        OptionsForm->Language->Items->Strings[3] = "";
        OptionsForm->Language->Items->Strings[4] = "";
        OptionsForm->Language->Items->Strings[5] = "";
        OptionsForm->ShowStatCheckBox->Caption =
            "   ";
        OptionsForm->ShowCatContCheckBox->Caption =
            "     -";
        OptionsForm->HideOnStartCheckBox->Caption =
            "     ";
        OptionsForm->Label2->Caption =
            "  -  :";
        OptionsForm->LogSessionsCheckBox->Caption = "";
        OptionsForm->LogConnectsCheckBox->Caption = "";
        OptionsForm->LogFilesCheckBox->Caption =
            "  ()";
        OptionsForm->LogHeadersCheckBox->Caption =
            "  ";
        AboutBox->Caption = " ";
        AboutBox->OKButton->Caption = "";
        AboutBox->Label2->Caption =
            "       -";
        AboutBox->Version->Caption = " "+AboutBox->ProgVersion;
        AboutBox->Author->Caption =
            " ̳ 븢"+the_year;
        AboutBox->Label3->Caption = "WWW  :";
        AboutBox->Label4->Caption = " E-MAIL:";
        AboutBox->Freeware->Caption =
            "  - FREEWARE.   "
            "( ) . "
            "   -  "
            " .    "
            "      "
            "e-mail  WWW .";
   //     AboutBox->Adv->Caption = "( [ ]    )";
        AboutBox->MyForum->Caption = " ";
        OptionsForm->LogDebugCheckBox->Caption =
            "( )";
        OptionsForm->LogRemoteHostsCheckBox->Caption =
            " ";
        OptionsForm->TabSheet3->Caption = " IP";
        OptionsForm->UseIPFilteringCheckBox->Caption =
            "     IP:";
        OptionsForm->IPFilterAdd->Caption =
            "  IP";
        OptionsForm->IPFilterEdit->Caption =
            "  IP";
        OptionsForm->IPFilterRemove->Caption =
            "  IP";
        OptionsForm->IPFiltersClear->Caption =
            " ";
        OptionsForm->SendServerHeaderCheckBox->Caption =
            " HTTP- \"Server:\"";
        OptionsForm->Label4->Caption =
            "URL   (CSS)  -:";
        OptionsForm->ECGICheckBox->Caption =
            " CGI";
        OptionsForm->Label5->Caption =
            " CGI:";
        OptionsForm->RestoreDefCGIDirButton->Caption =
            "<-   ";
        OptionsForm->USCGIFCheckBox->Caption =
            "    CGI :";
        OptionsForm->DNICGICheckBox->Caption =
            "   -   CGI";
        OptionsForm->TabSheet5->Caption = "";
        OptionsForm->DPAFCheckBox->Caption =
            ",     , "
            " (  UNIX)";
        OptionsForm->AEASCCheckBox->Caption =
            "   HTTP  -";
        OptionsForm->DIPIVCheckBox->Caption =
            " IP   CGI  :";
        OptionsForm->CGIAssocGroupBox->Caption =
            " CGI-";
        OptionsForm->CGIAssocAdd->Caption =
            " ";
        OptionsForm->CGIAssocEdit->Caption =
            " ";
        OptionsForm->CGIAssocRemove->Caption =
            " ";
        OptionsForm->CGIAssocClear->Caption =
            " ";
        OptionsForm->AddRootButton->Hint =
            "    ";
        OptionsForm->RemoveRootButton->Hint =
            "   ";
        OptionsForm->ErrFilesLabel->Caption =
            "   (   URL):";
        OptionsForm->KLOECheckBox->Caption =
            " -   -";
        AboutBox->Star->Hint = " ";
        AboutBox->Sun->Hint = " ";
    break;
    case 3: //
        OptionsButton->Caption = "...";
        AboutBtn->Hint = " Son hServer";
        HideButton->Caption = "";
        Label2->Caption = ":";
        Restore->Caption = "";
        Exit->Caption = "";
        OptionsForm->Caption = " ";
        OptionsForm->TabSheet1->Caption = "";
        OptionsForm->TabSheet2->Caption = "";
        OptionsForm->OKButton->Caption = "";
        OptionsForm->CancelButton->Caption = "";
        OptionsForm->Label1->Caption = "  :";
        OptionsForm->Label3->Caption = ":";
        OptionsForm->Language->Items->Strings[0] = "";
        OptionsForm->Language->Items->Strings[1] = "";
        OptionsForm->Language->Items->Strings[2] = "";
        OptionsForm->Language->Items->Strings[3] = "";
        OptionsForm->Language->Items->Strings[4] = "";
        OptionsForm->Language->Items->Strings[5] = "";
        OptionsForm->ShowStatCheckBox->Caption =
            "   ";
        OptionsForm->ShowCatContCheckBox->Caption =
            "      ";
        OptionsForm->HideOnStartCheckBox->Caption =
            "    ";
        OptionsForm->Label2->Caption =
            "     :";
        OptionsForm->LogSessionsCheckBox->Caption = "";
        OptionsForm->LogConnectsCheckBox->Caption = "";
        OptionsForm->LogFilesCheckBox->Caption =
            "  ()";
        OptionsForm->LogHeadersCheckBox->Caption =
            "   ";
        AboutBox->Caption = "";
        AboutBox->OKButton->Caption = "";
        AboutBox->Label2->Caption =
            "         ";
        AboutBox->Version->Caption = " "+AboutBox->ProgVersion;
        AboutBox->Author->Caption =
            "  "+the_year;
        AboutBox->Label3->Caption = "WWW :";
        AboutBox->Label4->Caption = " -:";
        AboutBox->Freeware->Caption =
            "  - .   "
            "(  ) . "
            "     "
            " .    "
            "       "
            "-  WWW .";
   //     AboutBox->Adv->Caption = "( [ ]    )";
        AboutBox->MyForum->Caption = " ";
        OptionsForm->LogDebugCheckBox->Caption =
            "( )";
        OptionsForm->LogRemoteHostsCheckBox->Caption =
            " ";
        OptionsForm->TabSheet3->Caption = " ";
        OptionsForm->UseIPFilteringCheckBox->Caption =
            "     :";
        OptionsForm->IPFilterAdd->Caption =
            "  ";
        OptionsForm->IPFilterEdit->Caption =
            "  ";
        OptionsForm->IPFilterRemove->Caption =
            "  ";
        OptionsForm->IPFiltersClear->Caption =
            " ";
        OptionsForm->SendServerHeaderCheckBox->Caption =
            " - \"Server:\"";
        OptionsForm->Label4->Caption =
            "    ()   :";
        OptionsForm->ECGICheckBox->Caption =
            " ";
        OptionsForm->Label5->Caption =
            " :";
        OptionsForm->RestoreDefCGIDirButton->Caption =
            "<-   ";
        OptionsForm->USCGIFCheckBox->Caption =
            "     :";
        OptionsForm->DNICGICheckBox->Caption =
            "  -   ";
        OptionsForm->TabSheet5->Caption = "";
        OptionsForm->DPAFCheckBox->Caption =
            "     ,  "
            " (  )";
        OptionsForm->AEASCCheckBox->Caption =
            "       ";
        OptionsForm->DIPIVCheckBox->Caption =
            "      :";
        OptionsForm->CGIAssocGroupBox->Caption =
            " -";
        OptionsForm->CGIAssocAdd->Caption =
            " ";
        OptionsForm->CGIAssocEdit->Caption =
            " ";
        OptionsForm->CGIAssocRemove->Caption =
            " ";
        OptionsForm->CGIAssocClear->Caption =
            " ";
        OptionsForm->AddRootButton->Hint =
            "    ";
        OptionsForm->RemoveRootButton->Hint =
            "   ";
        OptionsForm->ErrFilesLabel->Caption =
            "   (   URL):";
        OptionsForm->KLOECheckBox->Caption =
            "      ";
        AboutBox->Star->Hint = " ";
        AboutBox->Sun->Hint = " ";
    break;
    case 4: //Ua
        OptionsButton->Caption = "...";
        AboutBtn->Hint = "  Son hServer";
        HideButton->Caption = "";
        Label2->Caption = ":";
        Restore->Caption = "";
        Exit->Caption = "";
        OptionsForm->Caption = " ";
        OptionsForm->TabSheet1->Caption = "";
        OptionsForm->TabSheet2->Caption = "";
        OptionsForm->OKButton->Caption = "";
        OptionsForm->CancelButton->Caption = "";
        OptionsForm->Label1->Caption = "  :";
        OptionsForm->Label3->Caption = " :";
        OptionsForm->Language->Items->Strings[0] = "";
        OptionsForm->Language->Items->Strings[1] = "";
        OptionsForm->Language->Items->Strings[2] = "";
        OptionsForm->Language->Items->Strings[3] = "";
        OptionsForm->Language->Items->Strings[4] = "";
        OptionsForm->Language->Items->Strings[5] = "";
        OptionsForm->ShowStatCheckBox->Caption =
            "   ";
        OptionsForm->ShowCatContCheckBox->Caption =
            "     -";
        OptionsForm->HideOnStartCheckBox->Caption =
            "     ";
        OptionsForm->Label2->Caption =
            "  -  :";
        OptionsForm->LogSessionsCheckBox->Caption = "";
        OptionsForm->LogConnectsCheckBox->Caption = "'";
        OptionsForm->LogFilesCheckBox->Caption =
            "  ()";
        OptionsForm->LogHeadersCheckBox->Caption =
            " 볺 ";
        AboutBox->Caption = " ";
        AboutBox->OKButton->Caption = "";
        AboutBox->Label2->Caption =
            "       -";
        AboutBox->Version->Caption = " "+AboutBox->ProgVersion;
        AboutBox->Author->Caption =
            "  "+the_year;
        AboutBox->Label3->Caption = "WWW  :";
        AboutBox->Label4->Caption = " E-MAIL:";
        AboutBox->Freeware->Caption =
            "  - FREEWARE. -  "
            "( ) . "
            "   -  "
            " .    "
            "      "
            "e-mail  WWW .";
   //     AboutBox->Adv->Caption = "( [ ]    )";
        AboutBox->MyForum->Caption = " ";
        OptionsForm->LogDebugCheckBox->Caption =
            "( )";
        OptionsForm->LogRemoteHostsCheckBox->Caption =
            " ";
        OptionsForm->TabSheet3->Caption = "Գ IP";
        OptionsForm->UseIPFilteringCheckBox->Caption =
            "  '   IP:";
        OptionsForm->IPFilterAdd->Caption =
            "  IP";
        OptionsForm->IPFilterEdit->Caption =
            "  IP";
        OptionsForm->IPFilterRemove->Caption =
            "  IP";
        OptionsForm->IPFiltersClear->Caption =
            " ";
        OptionsForm->SendServerHeaderCheckBox->Caption =
            "  HTTP \"Server:\"";
        OptionsForm->Label4->Caption =
            "URL   (CSS)  -:";
        OptionsForm->ECGICheckBox->Caption =
            " CGI";
        OptionsForm->Label5->Caption =
            " CGI:";
        OptionsForm->RestoreDefCGIDirButton->Caption =
            "<-   ";
        OptionsForm->USCGIFCheckBox->Caption =
            "    CGI :";
        OptionsForm->DNICGICheckBox->Caption =
            "   -   CGI";
        OptionsForm->TabSheet5->Caption = "";
        OptionsForm->DPAFCheckBox->Caption =
            ", '    ,  "
            "(  UNIX)";
        OptionsForm->AEASCCheckBox->Caption =
            "   HTTP  -";
        OptionsForm->DIPIVCheckBox->Caption =
            " IP   CGI  :";
        OptionsForm->CGIAssocGroupBox->Caption =
            " CGI-";
        OptionsForm->CGIAssocAdd->Caption =
            " ";
        OptionsForm->CGIAssocEdit->Caption =
            " ";
        OptionsForm->CGIAssocRemove->Caption =
            " ";
        OptionsForm->CGIAssocClear->Caption =
            " ";
        OptionsForm->AddRootButton->Hint =
            "    ";
        OptionsForm->RemoveRootButton->Hint =
            "   ";
        OptionsForm->ErrFilesLabel->Caption =
            "   (   URL):";
        OptionsForm->KLOECheckBox->Caption =
            " -   -";
        AboutBox->Star->Hint = " ";
        AboutBox->Sun->Hint = " ";
    break;
    case 5: //Bg
        OptionsButton->Caption = "...";
        AboutBtn->Hint = "  Son hServer";
        HideButton->Caption = "";
        Label2->Caption = ":";
        Restore->Caption = "";
        Exit->Caption = "";
        OptionsForm->Caption = "  ";
        OptionsForm->TabSheet1->Caption = "";
        OptionsForm->TabSheet2->Caption = "";
        OptionsForm->OKButton->Caption = "";
        OptionsForm->CancelButton->Caption = "";
        OptionsForm->Label1->Caption = "   :";
        OptionsForm->Label3->Caption = ":";
        OptionsForm->Language->Items->Strings[0] = "";
        OptionsForm->Language->Items->Strings[1] = "";
        OptionsForm->Language->Items->Strings[2] = "";
        OptionsForm->Language->Items->Strings[3] = "";
        OptionsForm->Language->Items->Strings[4] = "";
        OptionsForm->Language->Items->Strings[5] = "";
        OptionsForm->ShowStatCheckBox->Caption =
            "    ";
        OptionsForm->ShowCatContCheckBox->Caption =
            "   ,    ";
        OptionsForm->HideOnStartCheckBox->Caption =
            "     ";
        OptionsForm->Label2->Caption =
            "      :";
        OptionsForm->LogSessionsCheckBox->Caption = "";
        OptionsForm->LogConnectsCheckBox->Caption = "";
        OptionsForm->LogFilesCheckBox->Caption =
            "  ()";
        OptionsForm->LogHeadersCheckBox->Caption =
            "   ";
        AboutBox->Caption = " ";
        AboutBox->OKButton->Caption = "";
        AboutBox->Label2->Caption =
            "         ";
        AboutBox->Version->Caption = " "+AboutBox->ProgVersion;
        AboutBox->Author->Caption =
            "  "+the_year;
        AboutBox->Label3->Caption = "WWW   :";
        AboutBox->Label4->Caption = " :";
        AboutBox->Freeware->Caption =
            "   .   "
            "( ) . "
            "     "
            " .    "
            "       "
            "Email  WWW .";
   //     AboutBox->Adv->Caption = "( [ ]    )";
        AboutBox->MyForum->Caption = "  ";
        OptionsForm->LogDebugCheckBox->Caption =
            "(  )";
        OptionsForm->LogRemoteHostsCheckBox->Caption =
            " ";
        OptionsForm->TabSheet3->Caption = "  IP";
        OptionsForm->UseIPFilteringCheckBox->Caption =
            "   IP :";
        OptionsForm->IPFilterAdd->Caption =
            "  IP ";
        OptionsForm->IPFilterEdit->Caption =
            "    IP";
        OptionsForm->IPFilterRemove->Caption =
            "  IP ";
        OptionsForm->IPFiltersClear->Caption =
            "  ";
        OptionsForm->SendServerHeaderCheckBox->Caption =
            "  HTTP  \"Server:\"";
        OptionsForm->Label4->Caption =
            "URL   (CSS)   :";
        OptionsForm->ECGICheckBox->Caption =
            "  CGI";
        OptionsForm->Label5->Caption =
            " CGI:";
        OptionsForm->RestoreDefCGIDirButton->Caption =
            "<-   ";
        OptionsForm->USCGIFCheckBox->Caption =
            "     CGI :";
        OptionsForm->DNICGICheckBox->Caption =
            "    -   CGI";
        OptionsForm->TabSheet5->Caption = "";
        OptionsForm->DPAFCheckBox->Caption =
            ",     ,    "
            "(  UNIX)";
        OptionsForm->AEASCCheckBox->Caption =
            " HTTP     ";
        OptionsForm->DIPIVCheckBox->Caption =
            "  IP  CGI   :";
        OptionsForm->CGIAssocGroupBox->Caption =
            "  CGI ";
        OptionsForm->CGIAssocAdd->Caption =
            "  ";
        OptionsForm->CGIAssocEdit->Caption =
            "  ";
        OptionsForm->CGIAssocRemove->Caption =
            "  ";
        OptionsForm->CGIAssocClear->Caption =
            "  ";
        OptionsForm->AddRootButton->Hint =
            "     ";
        OptionsForm->RemoveRootButton->Hint =
            "    ";
        OptionsForm->ErrFilesLabel->Caption =
            "   (   URL ):";
        OptionsForm->KLOECheckBox->Caption =
            "       ";
        AboutBox->Star->Hint = " ";
        AboutBox->Sun->Hint = "";
    break;
    default: //En
        OptionsButton->Caption = "Options...";
        AboutBtn->Hint = "About Son hServer";
        HideButton->Caption = "Hide";
        Label2->Caption = "Statistics:";
        Restore->Caption = "Show";
        Exit->Caption = "Exit";
        OptionsForm->Caption = "Server options";
        OptionsForm->TabSheet1->Caption = "Main";
        OptionsForm->TabSheet2->Caption = "Logs";
        OptionsForm->OKButton->Caption = "OK";
        OptionsForm->CancelButton->Caption = "Cancel";
        OptionsForm->Label1->Caption = "Server root path:";
        OptionsForm->Label3->Caption = "Interface language:";
        OptionsForm->Language->Items->Strings[0] = "Russian";
        OptionsForm->Language->Items->Strings[1] = "English";
        OptionsForm->Language->Items->Strings[2] = "Belorussian";
        OptionsForm->Language->Items->Strings[3] = "Serbian";
        OptionsForm->Language->Items->Strings[4] = "Ukrainian";
        OptionsForm->Language->Items->Strings[5] = "Bulgarian";
        OptionsForm->ShowStatCheckBox->Caption =
            "Monitor statistics at runtime";
        OptionsForm->ShowCatContCheckBox->Caption =
            "Show catalog contents when no index file exist";
        OptionsForm->HideOnStartCheckBox->Caption =
            "Hide in system tray when start";
        OptionsForm->Label2->Caption =
            "Save in log file information on:";
        OptionsForm->LogSessionsCheckBox->Caption = "sessions";
        OptionsForm->LogConnectsCheckBox->Caption = "connections";
        OptionsForm->LogFilesCheckBox->Caption =
            "requested files (paths)";
        OptionsForm->LogHeadersCheckBox->Caption =
            "client request headers";
        AboutBox->Caption = "About program";
        AboutBox->OKButton->Caption = "OK";
        AboutBox->Label2->Caption =
            "Now Your son can have his own home web server";
        AboutBox->Version->Caption = "Version "+AboutBox->ProgVersion;
        AboutBox->Author->Caption =
            "The author Mikhail Shmelev"+the_year;
        AboutBox->Label3->Caption = "Author\'s WWW site:";
        AboutBox->Label4->Caption = "Contact E-MAIL:";
        AboutBox->Freeware->Caption =
            "This program is FREEWARE. Any use "
            "(including commercial) is free. "
            "Author don't provide any technical "
            "support formally. But in case of "
            "problems You may try to get help via "
            "e-mail or WWW site.";
  //      AboutBox->Adv->Caption = "(Here could be Your advertisement)";
        AboutBox->MyForum->Caption = "Author`s forum";
        OptionsForm->LogDebugCheckBox->Caption =
            "(debug info)";
        OptionsForm->LogRemoteHostsCheckBox->Caption =
            "remote hosts";
        OptionsForm->TabSheet3->Caption = "IP filtering";
        OptionsForm->UseIPFilteringCheckBox->Caption =
            "Do not permit connections from following IPs:";
        OptionsForm->IPFilterAdd->Caption =
            "Add IP range";
        OptionsForm->IPFilterEdit->Caption =
            "Edit IP range";
        OptionsForm->IPFilterRemove->Caption =
            "Remove IP range";
        OptionsForm->IPFiltersClear->Caption =
            "Clear the list";
        OptionsForm->SendServerHeaderCheckBox->Caption =
            "Send \"Server:\" HTTP header";
        OptionsForm->Label4->Caption =
            "Stylesheet (CSS) file URL for index-pages:";
        OptionsForm->ECGICheckBox->Caption =
            "Enable CGI";
        OptionsForm->Label5->Caption =
            "CGI dir:";
        OptionsForm->RestoreDefCGIDirButton->Caption =
            "<- Reset to default";
        OptionsForm->USCGIFCheckBox->Caption =
            "Use separate folder for CGI dir:";
        OptionsForm->DNICGICheckBox->Caption =
            "Denie access to non-programs in CGI dir";
        OptionsForm->TabSheet5->Caption = "Compatibility";
        OptionsForm->DPAFCheckBox->Caption =
            "File which name begins with point is inaccessible"
            " (like in UNIX)";
        OptionsForm->AEASCCheckBox->Caption =
            "Report all HTTP errors as status codes";
        OptionsForm->DIPIVCheckBox->Caption =
            "Duplicate IP for CGI applications in variable:";
        OptionsForm->CGIAssocGroupBox->Caption =
            "CGI script associations";
        OptionsForm->CGIAssocAdd->Caption =
            "Add association";
        OptionsForm->CGIAssocEdit->Caption =
            "Edit association";
        OptionsForm->CGIAssocRemove->Caption =
            "Remove association";
        OptionsForm->CGIAssocClear->Caption =
            "Clear all";
        OptionsForm->AddRootButton->Hint =
            "Add root to pathlist";
        OptionsForm->RemoveRootButton->Hint =
            "Remove from pathlist";
        OptionsForm->ErrFilesLabel->Caption =
            "Files of error pages (local paths or URL):";
        OptionsForm->KLOECheckBox->Caption =
            "Delete log file on server program finish";
        AboutBox->Star->Hint = "See stars";
        AboutBox->Sun->Hint = "Sunrise";
    }//end switch
    if (! PreventSaveLangReg)
        SaveLangReg();
    PreventSaveLangReg=false;
}//end TForm1::LangComboBoxChange
//---------------------------------------------------------------------------

void __fastcall TForm1::OptionsButtonClick(TObject *Sender)
{
    OptionsForm->ShowModal();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::AboutBtnClick(TObject *Sender)
{
    AboutBox->ShowModal();
}
//---------------------------------------------------------------------------


void TForm1::LoadReg(void)
{
    //TODO: Add your source code here
    TIniFile *IniFile;
    AnsiString /*Key,*/ kv;
    int wiplen=0, cgiasslen=0, rootlistlen=0;
    int i;
    IniFile = new TIniFile(IniFileName);
//    Key="Software\\Super-M\\Son hServer";
    try
    {
      if (IniFile->SectionExists("General"))
      {
        //IniFile->OpenKeyReadOnly(Key);
        if (IniFile->ValueExists("General", "RC"))
          RootCatalog = IniFile->ReadString("General", "RC", "error");
        if (IniFile->ValueExists("General", "LS"))
          LogSessions = IniFile->ReadBool("General", "LS", true);
        if (IniFile->ValueExists("General", "LC"))
          LogConnects = IniFile->ReadBool("General", "LC", true);
        if (IniFile->ValueExists("General", "LF"))
          LogFiles = IniFile->ReadBool("General", "LF", true);
        if (IniFile->ValueExists("General", "LH"))
          LogHeaders = IniFile->ReadBool("General", "LH", false);
        if (IniFile->ValueExists("General", "L"))
          Lang = IniFile->ReadInteger("General", "L", 1/*en*/);
        if (IniFile->ValueExists("General", "SRS"))
          ShowRuntimeStatistics = IniFile->ReadBool("General", "SRS", true);
        if (IniFile->ValueExists("General", "SCC"))
          ShowCatalogContents = IniFile->ReadBool("General", "SCC", true);
        if (IniFile->ValueExists("General", "HOS"))
          HideOnStart = IniFile->ReadBool("General", "HOS", false);
        if (IniFile->ValueExists("General", "LD"))
          LogDebug = IniFile->ReadBool("General", "LD", false);
        if (IniFile->ValueExists("General", "LRH"))
          LogRemoteHosts = IniFile->ReadBool("General", "LRH", false);
        if (IniFile->ValueExists("General", "UIPF"))
          UseIPFiltering = IniFile->ReadBool("General", "UIPF", false);
        if (IniFile->ValueExists("General", "WrongIPListLen"))
          wiplen = IniFile->ReadInteger("General", "WrongIPListLen", 0);
        if (IniFile->ValueExists("General", "SSH"))
          SendServerHeader = IniFile->ReadBool("General", "SSH", false);
        if (IniFile->ValueExists("General", "ICURL"))
          IndexCssURL = IniFile->ReadString("General", "ICURL", "error");
        if (IniFile->ValueExists("General", "CGID"))
          CGIDir = IniFile->ReadString("General", "CGID", "error");
        if (IniFile->ValueExists("General", "ECGI"))
          EnableCGI = IniFile->ReadBool("General", "ECGI", true);
        if (IniFile->ValueExists("General", "USCGIF"))
          UseSepCGIFolder = IniFile->ReadBool("General", "USCGIF", false);
        if (IniFile->ValueExists("General", "SCGIF"))
          SeparateCGIFolder = IniFile->ReadString("General", "SCGIF", "error");
        if (IniFile->ValueExists("General", "DNICGI"))
          DenieNonprogramsInCGI = IniFile->ReadBool("General", "DNICGI", false);
        if (IniFile->ValueExists("General", "DPAF"))
          DeniePointAtFirst = IniFile->ReadBool("General", "DPAF", true);
        if (IniFile->ValueExists("General", "AEASC"))
          AllErrorsAsStatusCodes = IniFile->ReadBool("General", "AEASC", true);
        if (IniFile->ValueExists("General", "DIPIV"))
          DuplicateIPInVar = IniFile->ReadBool("General", "DIPIV", false);
        if (IniFile->ValueExists("General", "DIPV"))
          DuplicateIPVar = IniFile->ReadString("General", "DIPV", "error");
        if (IniFile->ValueExists("General", "EP404"))
          ErrorFile404 = IniFile->ReadString("General", "EP404", "error");
        if (IniFile->ValueExists("General", "EP500"))
          ErrorFile500 = IniFile->ReadString("General", "EP500", "error");
        if (IniFile->ValueExists("General", "EP403"))
          ErrorFile403 = IniFile->ReadString("General", "EP403", "error");
        if (IniFile->ValueExists("General", "KLOE"))
          KillLogOnExit = IniFile->ReadBool("General", "KLOE", false);
        if (IniFile->ValueExists("General", "U403"))
          Use403 = IniFile->ReadBool("General", "U403", false);
        if (IniFile->ValueExists("General", "CGIAssocListLen"))
          cgiasslen = IniFile->ReadInteger("General", "CGIAssocListLen", 0);
        if (IniFile->ValueExists("General", "RootListLen"))
          rootlistlen = IniFile->ReadInteger("General", "RootListLen", 0);
        //IniFile->CloseKey();
      }//end if
      if ( (wiplen>0) && IniFile->SectionExists("WrongIPs") )
      {
            if (IPFilters->Count>0) IPFilters->Clear();
            for (i=0; i<wiplen; i++)
            {
              kv = ConcatStrNum("IP",i);
              if (IniFile->ValueExists("WrongIPs", kv))
                IPFilters->Add(IniFile->ReadString("WrongIPs", kv, "error"));
            }
      }
      if ( (cgiasslen>0) && IniFile->SectionExists("CGIAssoc") )
      {
            if (CGIAssociations->Count>0) CGIAssociations->Clear();
            for (i=0; i<cgiasslen; i++)
            {
              kv = ConcatStrNum("CGI",i);
              if (IniFile->ValueExists("CGIAssoc", kv))
                CGIAssociations->Add(IniFile->ReadString("CGIAssoc", kv, "error"));
            }
      }
      if ( (rootlistlen>0) && IniFile->SectionExists("Roots") )
      {
            if (RootList->Count>0) RootList->Clear();
            for (i=0; i<rootlistlen; i++)
            {
              kv = ConcatStrNum("Root",i);
              if (IniFile->ValueExists("Roots", kv))
                RootList->Add(IniFile->ReadString("Roots", kv, "error"));
            }
      }
    }//end try
    catch (...)
    {
       Application->MessageBox(
        ",   \n"
        "     ",
        "    ",
        MB_OK | MB_ICONERROR);
    }
    delete IniFile;
}//end TForm1::LoadReg
//---------

void TForm1::SaveReg(void)
{
    //TODO: Add your source code here
    TIniFile *IniFile;
    AnsiString /*Key,*/ kv;
    int wiplen, cgiasslen, rootlistlen;
    int i;
    IniFile = new TIniFile(IniFileName);
//    Key="Software\\Super-M\\Son hServer";
    try
    {
        IniFile->WriteString("General", "RC", RootCatalog);
        IniFile->WriteBool("General", "LS", LogSessions);
        IniFile->WriteBool("General", "LC", LogConnects);
        IniFile->WriteBool("General", "LF", LogFiles);
        IniFile->WriteBool("General", "LH", LogHeaders);
        IniFile->WriteInteger("General", "L", Lang);
        IniFile->WriteBool("General", "SRS", ShowRuntimeStatistics);
        IniFile->WriteBool("General", "SCC", ShowCatalogContents);
        IniFile->WriteBool("General", "HOS", HideOnStart);
        IniFile->WriteBool("General", "LD", LogDebug);
        IniFile->WriteBool("General", "LRH", LogRemoteHosts);
        IniFile->WriteBool("General", "UIPF", UseIPFiltering);
        wiplen = IPFilters->Count;
        IniFile->WriteInteger("General", "WrongIPListLen", wiplen);
        IniFile->WriteBool("General", "SSH", SendServerHeader);
        IniFile->WriteString("General", "ICURL", IndexCssURL);
        IniFile->WriteString("General", "CGID", CGIDir);
        IniFile->WriteBool("General", "ECGI", EnableCGI);
        IniFile->WriteBool("General", "USCGIF", UseSepCGIFolder);
        IniFile->WriteString("General", "SCGIF", SeparateCGIFolder);
        IniFile->WriteBool("General", "DNICGI", DenieNonprogramsInCGI);
        IniFile->WriteBool("General", "DPAF", DeniePointAtFirst);
        IniFile->WriteBool("General", "AEASC", AllErrorsAsStatusCodes);
        IniFile->WriteBool("General", "DIPIV", DuplicateIPInVar);
        IniFile->WriteString("General", "DIPV", DuplicateIPVar);
        IniFile->WriteString("General", "EP404", ErrorFile404);
        IniFile->WriteString("General", "EP500", ErrorFile500);
        IniFile->WriteString("General", "EP403", ErrorFile403);
        IniFile->WriteBool("General", "KLOE", KillLogOnExit);
        IniFile->WriteBool("General", "U403", Use403);
        cgiasslen = CGIAssociations->Count;
        IniFile->WriteInteger("General", "CGIAssocListLen", cgiasslen);
        rootlistlen = RootList->Count;
        IniFile->WriteInteger("General", "RootListLen", rootlistlen);
        if (wiplen>0)
        {
            for (i=0; i<wiplen; i++)
            {
                IniFile->WriteString("WrongIPs", ConcatStrNum("IP",i),
                    IPFilters->Strings[i]);
            }
            while ( IniFile->ValueExists("WrongIPs", (kv=ConcatStrNum("IP",i))) )
            {
              IniFile->DeleteKey("WrongIPs", kv);  i++;
            }
        }
        if (cgiasslen>0)
        {
            for (i=0; i<cgiasslen; i++)
            {
                IniFile->WriteString("CGIAssoc", ConcatStrNum("CGI",i),
                    CGIAssociations->Strings[i]);
            }
            while ( IniFile->ValueExists("CGIAssoc", (kv=ConcatStrNum("CGI",i))) )
            {
              IniFile->DeleteKey("CGIAssoc", kv);  i++;
            }
        }
        if (rootlistlen>0)
        {
            for (i=0; i<rootlistlen; i++)
            {
                IniFile->WriteString("Roots", ConcatStrNum("Root",i),
                    RootList->Strings[i]);
            }
            while ( IniFile->ValueExists("Roots", (kv=ConcatStrNum("Root",i))) )
            {
              IniFile->DeleteKey("Roots", kv);  i++;
            }
        }
        IniFile->UpdateFile();
    }//end try
    catch (...)
    {
      Application->MessageBox(
        ",   \n"
        "     ",
        "     ",
        MB_OK | MB_ICONERROR);
    }
    delete IniFile;
}//end TForm1::SaveReg
//---------

void TForm1::SaveLangReg(void)
{//save only Lang
    //TODO: Add your source code here
    TIniFile *IniFile;
    IniFile = new TIniFile(IniFileName);
//    Key="Software\\Super-M\\Son hServer";
    try
    {
        IniFile->WriteInteger("General", "L", Lang);
        IniFile->UpdateFile();
    }//end try
    catch (...)
    {
      Application->MessageBox(
        ",   \n"
        "     ",
        "      ",
        MB_OK | MB_ICONERROR);
    }
    delete IniFile;
    //SaveReg(); //temporarily
}//end TForm1::SaveLangReg
//---------

void __fastcall TForm1::RestoreClick(TObject *Sender)
{
Application->Restore();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ExitClick(TObject *Sender)
{
Close();
}
//---------------------------------------------------------------------------

void __fastcall TForm1::HideButtonClick(TObject *Sender)
{
Application->Minimize();
}
//---------------------------------------------------------------------------


int TForm1::ExtractHTTPVersion(AnsiString hvs)
{//extracts HTTP minor version
    //TODO: Add your source code here
    int len, maj, min, pnt_pos, ret=0;
    len = hvs.Length();
    if ((len<8) || (hvs.SubString(1,5)!="HTTP/"))
        ret = -1000;
    else
    {
        //log("else");
        pnt_pos = hvs.Pos(".");
        try
        {
            maj = hvs.SubString(6,pnt_pos-6).ToInt();
        }
        catch (...) { ret = -1000; /*log("catch maj");*/ }
        try
        {
            min = hvs.SubString(pnt_pos+1,len-pnt_pos).ToInt();
        }
        catch (...) { ret = -1000; /*log("catch min");*/ }
        if (ret>=0)
        {
            if (maj==1)
                ret = min;
            else
            {
                if (maj<1) ret = -1000;
                else ret = 1000*maj + min;
            }
        }//end if
    }//end else
    return ret;
}//end TForm1::ExtractHTTPVersion
//----------------

AnsiString TForm1::GenHTTPDate(FILETIME& fdate)
{
    //TODO: Add your source code here
    //TDateTime date;
    SYSTEMTIME st;
    AnsiString ret;
    int year, month, day, h, m, s, /*ms,*/ dow;
    char *wkdays[7] = {"Sun", "Mon", "Tue", "Wed",
        "Thu", "Fri", "Sat"};
    char *months[12] = {"Jan", "Feb", "Mar", "Apr",
        "May", "Jun", "Jul", "Aug",
        "Sep", "Oct", "Nov", "Dec"};
    if (::FileTimeToSystemTime(&fdate, &st))
    {
        //date = FileDateToDateTime(fdate);
        year = (int)st.wYear;  month = (int)st.wMonth;
        day = (int)st.wDay;  h = (int)st.wHour;
        m = (int)st.wMinute;  s = (int)st.wSecond;
        dow = (int)st.wDayOfWeek;
        ret.sprintf("%s, %02d %s %04d %02d:%02d:%02d GMT",
            wkdays[dow], day, months[month-1], year,
            h, m, s);
        //for debug:
        //log(ret);
    }
    return ret;
}//end TForm1::GenHTTPDate
//-----------

bool TForm1::TestWrongIP(AnsiString& whatip, AnsiString& ipmask)
{
    //TODO: Add your source code here
    char *_ip, *_mask;
    int _iplen, _masklen, i, j, step, masknmax=4;
    #define theIPmask i
    bool ret=true;
    bool is_asterisk[4] = { false, false, false, false };
    bool is_range[4] = { false, false, false, false };
    int ipstep, maskstep, ipbp, maskbp, ep, ipn[4], maskn[8];
    int maskbeg[4], maskend[4];
    bool use_globalrange=false;
    unsigned long theIP=0L, theBegIP=0L, theEndIP=0L;
    AnsiString tmp;
    _ip = whatip.c_str(); _mask = ipmask.c_str();
    _iplen = whatip.Length(); _masklen = ipmask.Length();
    //debug
    /*tmp.sprintf("_ip==%s ; _mask==%s ; _iplen==%d ; _masklen==%d",
            _ip, _mask, _iplen, _masklen);
    log("debug: TForm1::TestWrongIP\n"+tmp.c_str());*/
    ipstep = maskstep = 0;  ipbp = maskbp = 0;
    for (i=0; i<_iplen; i++)
    {
      if (((_ip[i]=='.')||(i==_iplen-1))&&(ipstep<4))
      {//add one of IP parts
        ep = (i==_iplen-1) ? (i+1) : i;
        tmp = whatip.SubString(ipbp+1, ep-ipbp); //+1 cause AnsiString
        try { ipn[ipstep]=tmp.ToInt(); }
        catch (...) { ipn[ipstep]=0; /*it should never happen for IP v4*/ }
        //debug
        /*tmp.sprintf(" ; ipbp==%d ; ep==%d ; i==%d",
            ipbp, ep, i);
        log("debug: _ip .\n"+tmp.c_str()); */
        ipstep++;  ipbp=ep+1;
      }
    }//end for i
    for (j=0; j<_masklen; j++)
    {
      if ((_mask[j]=='-')&&(maskstep<4))
      {//add begin of IP mask part range
        ep = j;
        if (maskstep==3)
          use_globalrange = (ep+4<_masklen);
        tmp = ipmask.SubString(maskbp+1, ep-maskbp); //+1 cause AnsiString
        try { maskbeg[maskstep]=tmp.ToInt(); }
        catch (...) { maskbeg[maskstep]=0; /*if fool_user-typed mask*/ }
        if (use_globalrange)
        {
            maskn[maskstep] = maskbeg[maskstep];  masknmax=8;
            maskstep++;  maskbp = ep+1;
        }
        else
            is_range[maskstep] = true;
        //debug
        /*tmp.sprintf(" ; maskbp==%d ; ep==%d ; j==%d",
            maskbp, ep, j);
        log("debug: _mask -\n"+tmp.c_str());*/
        maskbp = ep+1;
      }
      if ( ((_mask[j]=='.')||(j==_masklen-1))&&(maskstep<masknmax) )
      {//add end of IP mask part range or IP mask part
        ep = (j==_masklen-1) ? (j+1) : j;
        tmp = ipmask.SubString(maskbp+1, ep-maskbp); //+1 cause AnsiString
        if (tmp.Pos("*")==0) //not * mask
        {
         try { maskn[maskstep]=tmp.ToInt(); }
         catch (...) { maskn[maskstep]=0; /*if fool_user-typed mask*/ }
         if ( (maskstep<4) && is_range[maskstep] )
            maskend[maskstep] = maskn[maskstep];
        }
        else
        {
          maskn[maskstep] = (maskstep<4)?0:255;
          if (maskstep<4)
            is_asterisk[maskstep] = true;
        }
        //debug
        /*tmp.sprintf(" ; maskbp==%d ; ep==%d ; j==%d",
            maskbp, ep, j);
        log("debug: _mask .\n"+tmp.c_str()); */
        maskstep++;  maskbp = ep+1;
      }
    }//end for j
    if (ipstep!=4)
    {
        log(getNow()+"Strange IP address discovered: "+whatip);
        for (;ipstep<4; ipstep++)
            ipn[ipstep]=0;
    }
    if (maskstep!=4)
    {
        for (;maskstep<4; maskstep++)
            is_asterisk[maskstep]=true;
    }
    //debug
    /*tmp=""; tmp.sprintf("ipstep==%d ; maskstep==%d",
             ipstep, maskstep);
    log("debug: ipstep and maskstep\n"+tmp.c_str());
    tmp=""; tmp.sprintf("ipn[0]=%d ; ipn[1]=%d ; ipn[2]=%d ; ipn[3]=%d\n"
             "maskn[0]=%d ; maskn[1]=%d ; maskn[2]=%d ; maskn[3]=%d\n"
             "maskbeg[0]=%d ; maskbeg[1]=%d ; maskbeg[2]=%d ; maskbeg[3]=%d\n"
             "maskend[0]=%d ; maskend[1]=%d ; maskend[2]=%d ; maskend[3]=%d",
             ipn[0], ipn[1], ipn[2], ipn[3],
             maskn[0], maskn[1], maskn[2], maskn[3],
             maskbeg[0], maskbeg[1], maskbeg[2], maskbeg[3],
             maskend[0], maskend[1], maskend[2], maskend[3]);
    log("debug: address parts\n"+tmp.c_str()); */
    for (step=0; step<4; step++)
    {
      if (use_globalrange)
      {
        theIPmask = 1 << (8*(3-step));
        theIP += theIPmask * (ipn[step] & 0xFF);
        theBegIP += theIPmask * (maskn[step] & 0xFF);
        theEndIP += theIPmask * (maskn[step+4] & 0xFF);
      }
      else
      {
        if (!is_asterisk[step])
        {
            if (is_range[step])
                ret = ret && ( (ipn[step]>=maskbeg[step])&&
                 (ipn[step]<=maskend[step]) );
            else
                ret = ret && (ipn[step]==maskn[step]);
        }
      }
    }//end for step
    //debug
    /*tmp=""; tmp.sprintf("theIP=%d=%X ; theBegIP=%d=%X ; theEndIP=%d=%X",
             theIP, theIP, theBegIP, theBegIP, theEndIP, theEndIP);
    log("debug: numeral IPs; whatip=="+whatip+" ipmask=="+ipmask+"\n"+tmp);*/
    if (use_globalrange)
        ret = (theIP>=theBegIP)&&(theIP<=theEndIP);
    /*
    //this commented part can be used for IP v 6
    //but socket component must support IP v6
    bool asterisk_is=false;
    for (i=0, j=0; (i<_iplen)&&(j<_masklen)&&ret; i++)
    {
        if (_ip[i]=='.')
        {//skip to next . in _mask
            while ((j<_masklen)&&(_mask[j]!='.')) j++;
            asterisk_is = false;
        }
        if (_mask[j]!='*')
        {
            ret = ret && (_ip[i]==_mask[j]);
        }
        else
            asterisk_is = true;
        if (!asterisk_is) j++;
    }
    */
    #undef theIPmask
    return ret;
}//end TForm1::TestWrongIP
//-----------

AnsiString __fastcall TForm1::ConcatStrNum(AnsiString str, int num)
{
    //TODO: Add your source code here
    AnsiString ret;
    ret = str;
    ret.sprintf("%d", num);
    return ret;
}
//-------

void __fastcall TForm1::AppException(System::TObject* Sender, Sysutils::Exception* E)
{
    //TODO: Add your source code here
    AnsiString einfo;
    einfo = getNow()+" ERROR: Unhandled exception. Sender=="+
        Sender->ClassName()+"\n exception type: "+
        E->ClassName()+"\n Message: "+E->Message;
    log(einfo);  SessionTotalErrors++;
}
//--------

bool TForm1::CheckCGIDir(AnsiString& thedir)
{
    //TODO: Add your source code here
    char *pdir, *pcgidir, ch, cgich;
    int ldir, lcgidir;
    bool ret=true;
    pdir = thedir.c_str();
    ldir = thedir.Length();
    pcgidir = CGIDir.c_str();
    lcgidir = CGIDir.Length();
    if (ldir<lcgidir)
        ret=false;
    else
    {
        for (int i=0; ret&&(i<lcgidir); i++)
        {
            ch = pdir[i];  cgich = pcgidir[i];
            if ((ch>64)&&(ch<91))
                ch = (char)(ch + 32);
            if ((cgich>64)&&(cgich<91))
                cgich = (char)(cgich + 32);
            if (ch!=cgich)
                ret=false;
        }
    }
    return ret;
}//end TForm1::CheckCGIDir

__fastcall mAutocloseStream::mAutocloseStream(int AHandle) :
    THandleStream(AHandle)
{
}

__fastcall mAutocloseStream::~mAutocloseStream(void)
{
    CloseHandle((HANDLE)Handle);
}

int /*__fastcall*/ TForm1::RunCGI(mParser* p, int& bodysz/*, bool& noerr*/)
{
    //TODO: Add your source code here
    char *sptr, *csptr, cchar;
    int i=0, j=0, /*slen,*/ listLen;
    bool not_exceed=true, not_failed=true;
    AnsiString tempastr; //for debug
    //debug
    /*log("starting RunCGI");  */
    if (LogDebug)
        log("p->ExeApp == "+p->ExeApp);
    listLen = p->Headers->Count;
    sptr = CgiEnvString;
    // NOW let us add CGI env vars
    i=0;
    while ((i<listLen)&&not_exceed)
    {
        csptr = p->Headers->Strings[i].c_str();
        if ((i>=p->EnvVarsSize) &&
            (lstrcmpi(csptr, "content-type")!=0) &&
            (lstrcmpi(csptr, "content-length")!=0))
        {
            lstrcpy(sptr, "HTTP_");
            sptr += 5;  j += 5;
        }
        do
        {
            cchar = (*csptr);
            switch (cchar)
            {
            case '-':
            case ' ': cchar = '_'; break;
            case 0: cchar = '='; break;
            default:
                if ((cchar>96)&&(cchar<123))
                    cchar = (char)(cchar - 32);
            }
            (*sptr) = cchar;
            sptr++; csptr++; j++;
            not_exceed = (j<(CGI_ENV_SIZE-2));
        } while((cchar!='=')&&not_exceed);
        i++;
        if ((i<listLen)&&not_exceed)
        {
          csptr = p->Headers->Strings[i].c_str();
          do
          {
            cchar = (*csptr);
            (*sptr) = cchar;
            sptr++; csptr++; j++;
            not_exceed = (j<(CGI_ENV_SIZE-2));
          } while((cchar!=0)&&not_exceed);
          i++;
        }//end if
    }//end while i
    //Let us set DOCUMENT_ROOT
    int envLen;
    AnsiString tmp_docroot_var;
    char *tmp_docroot_var_str;
    if (not_exceed)
    {
      tmp_docroot_var = "DOCUMENT_ROOT=";
      tmp_docroot_var += RootCatalog;
      tmp_docroot_var_str = tmp_docroot_var.c_str();
      //envLen = tmp_docroot_var.Length();
      envLen = lstrlen(tmp_docroot_var_str);
      //putenv(tmp_docroot_var_str);
      lstrcpy(sptr, tmp_docroot_var_str);
      sptr += envLen + 1; j += envLen + 1;
      //debug
      if (LogDebug) { log("docroot set"); log(tmp_docroot_var); }
      //end debug
    }
    // NOW let us add env vars of calling process
    if (not_exceed)
    {
      for (i=0; (_environ[i]!=NULL) && not_exceed; i++)
      {
          envLen = lstrlen(_environ[i]);
          //debug
          if (LogDebug) log((AnsiString)_environ[i]);
          //end debug
          not_exceed = (j<(CGI_ENV_SIZE-envLen-2));
          if (not_exceed)
          {
            lstrcpy(sptr, _environ[i]);
            sptr += envLen + 1;
            j += envLen + 1;
          }//end if not_exceed
      }//end for i (_environ)
    }//end if not_exceed
    if (not_exceed)
        (*sptr) = '\000';
    else
        { (*sptr) = '\000';  sptr++;  (*sptr) = '\000'; }
    //now environment is ready.
    //debug
    //log((AnsiString)CgiEnvString);
    //end debug
  // Find empty name for TempStdoutFile
  i=0;
  do
  {
    wsprintf(TempStdoutFile, "out%d.tmp", i);  i++;
  } while(FileExists(TempStdoutFile));
  // Doing main operations for CGI
  HANDLE stdinFile, stdoutFile, stderrFile;
  DWORD BytesToWrite, BytesWritten=0, BytesRead=0;
  STARTUPINFO StartupInfo;
  PROCESS_INFORMATION ProcessInformation;
  BOOL IsStartedOk, IsReadOk;
  DWORD wfsoRet;
  AnsiString CmdLine, runDir;
  char *exeName;
/*#define IsReadOk IsStartedOk
#define BytesRead BytesWritten  */
  // Set run dir
  runDir = ExtractFilePath(p->LocalPath);
  // Make command line
  if (p->CGIType==CGITYPE_EXE)
  {
    exeName = p->LocalPath.c_str();
    CmdLine = (AnsiString)"\"" + exeName + "\"";
    //CmdLine = (AnsiString)">" + TempStdoutFile;
    //debug
    /*log("p->CGIType==CGITYPE_EXE");  */
  }
  else
  {
    exeName = p->ExeApp.c_str();  /*CmdLine = *exeName;*/
    //CmdLine = "\"" + p->ExeApp + "\"";
    CmdLine += (AnsiString)"\"" + exeName + "\" \"" + p->LocalPath + "\"";
    //debug
    /*log("p->CGIType!=CGITYPE_EXE");  */
  }
  // Determine whether request was generated by ISINDEX
  i = p->QueryString.Pos("=");
  if (i==0)
  {
    CmdLine += /*p->LocalPath + */HTTPDecode(p->QueryString);
  }
  if (LogDebug)
  {
    log("CmdLine == "+CmdLine);
    log("runDir == "+runDir);
    log((AnsiString)"exeName == "+exeName);
  }
  OSVERSIONINFO VersionInformation;
  BOOL GVEret;
  SECURITY_ATTRIBUTES ProcessAttributes;
  SECURITY_DESCRIPTOR SecurityDescriptor;
  //ACL Acl;
  VersionInformation.dwOSVersionInfoSize = sizeof(VersionInformation);
  GVEret = ::GetVersionEx(&VersionInformation);
  if (GVEret && (VersionInformation.dwPlatformId==VER_PLATFORM_WIN32_NT))
  {//if NT
    InitializeSecurityDescriptor(
      &SecurityDescriptor,	// address of security descriptor
      SECURITY_DESCRIPTOR_REVISION 	// revision level
    );
    if (! IsValidSecurityDescriptor(&SecurityDescriptor))
    {
      log("! IsValidSecurityDescriptor");
      bodysz=-1; return (int)INVALID_HANDLE_VALUE;
    }//end if(! IsValidSecurityDescriptor)
/*    Acl.AclRevision = ACL_REVISION;
    Acl.Sbz1 = 0;
    Acl.Sbz2 = 0;
    Acl.AceCount = 0;    */
    GVEret = SetSecurityDescriptorDacl(
      &SecurityDescriptor,	// address of security descriptor
      TRUE,	// flag for presence of discretionary ACL
      NULL,	// address of discretionary ACL
      FALSE 	// flag for default discretionary ACL
    );
    if (! GVEret)
    {
      log("! SetSecurityDescriptorDacl");
      bodysz=-1; return (int)INVALID_HANDLE_VALUE;
    }//end if(! SetSecurityDescriptorDacl)
/*    GVEret = SetSecurityDescriptorSacl(
      &SecurityDescriptor,	// address of security descriptor
      TRUE,	// flag for presence of system ACL
      NULL,	// address of system ACL
      TRUE 	// flag for default system ACL
    );
    if (! GVEret)
    {
      log("! SetSecurityDescriptorSacl");
      ::CloseHandle(stdinFile); ::CloseHandle(stdoutFile); ::CloseHandle(stderrFile);
      bodysz=-1; return (int)INVALID_HANDLE_VALUE;
    }//end if(! SetSecurityDescriptorSacl)
    */
  }//end if NT
  ProcessAttributes.lpSecurityDescriptor = &SecurityDescriptor;
  ProcessAttributes.bInheritHandle = TRUE;
  ProcessAttributes.nLength = sizeof(ProcessAttributes);
  // Create files for I/O redirect
  stdinFile = ::CreateFile(
    TempStdinFile,
    GENERIC_READ | GENERIC_WRITE,
    FILE_SHARE_DELETE,
    NULL,
    CREATE_ALWAYS,
    FILE_FLAG_SEQUENTIAL_SCAN/* | FILE_FLAG_DELETE_ON_CLOSE*/,
    NULL);
  if (stdinFile==INVALID_HANDLE_VALUE) //an error
  {
    log("stdinFile==INVALID_HANDLE_VALUE");
    bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
  //debug
  /*log((AnsiString)"TempStdoutFile=="+TempStdoutFile);  */
  //end debug
  stdoutFile = ::CreateFile(
    TempStdoutFile,
    GENERIC_READ | GENERIC_WRITE,
    FILE_SHARE_WRITE | FILE_SHARE_DELETE,
    &ProcessAttributes,
    CREATE_ALWAYS,
    FILE_FLAG_SEQUENTIAL_SCAN | FILE_FLAG_DELETE_ON_CLOSE/**/,
    NULL);
  if (stdoutFile==INVALID_HANDLE_VALUE) //an error
  {
    log("stdoutFile==INVALID_HANDLE_VALUE");
    ::CloseHandle(stdinFile);
    bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
  //debug
  /*tempastr = ""; tempastr.sprintf("stdoutFile==%d",
    stdoutFile);
  log(tempastr);  */
  //end debug
  stderrFile = ::CreateFile(
    TempStderrFile,
    GENERIC_READ | GENERIC_WRITE,
    FILE_SHARE_WRITE | FILE_SHARE_DELETE,
    &ProcessAttributes,
    CREATE_ALWAYS,
    FILE_ATTRIBUTE_TEMPORARY | FILE_FLAG_SEQUENTIAL_SCAN | FILE_FLAG_DELETE_ON_CLOSE/**/,
    NULL);
  if (stderrFile==INVALID_HANDLE_VALUE) //an error
  {
    log("stderrFile==INVALID_HANDLE_VALUE");
    ::CloseHandle(stdinFile); ::CloseHandle(stdoutFile);
    bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
  // Write request body
  BytesToWrite = p->Body.Length();
  ::WriteFile(
    stdinFile,
    p->Body.c_str(),
    BytesToWrite,
    &BytesWritten,
    NULL);
  //debug
  /*tempastr = ""; tempastr.sprintf("BytesToWrite==%d\nBytesWritten==%d\n"
    "stdinFile==%d\nstdoutFile==%d\nstderrFile==%d",
    BytesToWrite, BytesWritten, stdinFile, stdoutFile, stderrFile);
  log(tempastr);
  log("p->Body=="+p->Body+"\n");    */
  //end debug
  p->Body = ""; //to free memory
  if (BytesToWrite!=BytesWritten)
  {
    log("BytesToWrite!=BytesWritten");
    ::CloseHandle(stdinFile); ::CloseHandle(stdoutFile); ::CloseHandle(stderrFile);
    bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
  //temporary close stdinFile
  ::CloseHandle(stdinFile);
  //and open again
  stdinFile = ::CreateFile(
    TempStdinFile,
    GENERIC_READ | GENERIC_WRITE,
    FILE_SHARE_WRITE | FILE_SHARE_DELETE,
    &ProcessAttributes,
    OPEN_ALWAYS,
    FILE_FLAG_SEQUENTIAL_SCAN | FILE_FLAG_DELETE_ON_CLOSE,
    NULL);
  if (stdinFile==INVALID_HANDLE_VALUE) //an error
  {
    log("stdinFile==INVALID_HANDLE_VALUE");
    ::CloseHandle(stdinFile);
    bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
  //::SetFilePointer(stdinFile, 0, NULL, FILE_BEGIN);
/*  ::WriteFile(
    stdoutFile,
    "wow\n\n",
    5,
    &BytesWritten,
    NULL);
  ::SetFilePointer(stdoutFile, 0, NULL, FILE_BEGIN);  */
  //debug
  /*log("before setting StartupInfo."); */
  //end debug
  // Creating child process with I/O redirect
  StartupInfo.lpReserved = NULL;
  StartupInfo.lpDesktop = NULL;
  StartupInfo.lpTitle = NULL;
  StartupInfo.dwX = 0;
  StartupInfo.dwY = 0;
  StartupInfo.dwXSize = 300;
  StartupInfo.dwYSize = 150;
  StartupInfo.dwXCountChars = 80;
  StartupInfo.dwYCountChars = 25;
  StartupInfo.dwFillAttribute = 0;
  StartupInfo.dwFlags = STARTF_USESTDHANDLES | STARTF_USESHOWWINDOW;
  StartupInfo.wShowWindow = SW_HIDE | SW_SHOWMINNOACTIVE;
  StartupInfo.cbReserved2 = 0;
  StartupInfo.lpReserved2 = NULL;
  StartupInfo.hStdInput = stdinFile;
  StartupInfo.hStdOutput = stdoutFile;
  StartupInfo.hStdError = stderrFile;
  StartupInfo.cb = sizeof(StartupInfo);
  //debug
  /*log("before CreateProcess");  */
  //end debug
  if(VersionInformation.dwPlatformId==VER_PLATFORM_WIN32_NT)
  {
    IsStartedOk = ::CreateProcess(
      exeName, //app path
      CmdLine.c_str(), //cmd line
      &ProcessAttributes, // pointer to process security attributes
      &ProcessAttributes, // pointer to thread security attributes
      TRUE, // handle inheritance flag
      NORMAL_PRIORITY_CLASS | DETACHED_PROCESS/**/, // creation flags
      CgiEnvString, // pointer to new environment block
      runDir.c_str(), // pointer to current directory name
      &StartupInfo,
      &ProcessInformation);
  }
  else
  {
    IsStartedOk = ::CreateProcess(
      exeName, //app path
      CmdLine.c_str(), //cmd line
      NULL, // pointer to process security attributes
      NULL, // pointer to thread security attributes
      TRUE, // handle inheritance flag
      NORMAL_PRIORITY_CLASS | DETACHED_PROCESS, // creation flags
      CgiEnvString, // pointer to new environment block
      runDir.c_str(), // pointer to current directory name
      &StartupInfo,
      &ProcessInformation);
  }
  //debug
  /*tempastr=""; tempastr.sprintf("ProcessInformation.dwProcessId==%d\n"
    "ProcessInformation.hProcess==%d",
    ProcessInformation.dwProcessId, ProcessInformation.hProcess);
  log(tempastr);
  log("after CreateProcess");  */
  //end debug
  if (! IsStartedOk)
  {
    log("! IsStartedOk");
    ::CloseHandle(stdinFile); ::CloseHandle(stdoutFile); ::CloseHandle(stderrFile);
    bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
/*#define not_failed not_exceed  */
  HANDLE TheProcHdl;
  not_failed = true;
/*  TheProcHdl = OpenProcess(
    STANDARD_RIGHTS_REQUIRED | PROCESS_ALL_ACCESS | SYNCHRONIZE,	// access flag
    TRUE,	// handle inheritance flag
    ProcessInformation.dwProcessId 	// process identifier
  );
  ::CloseHandle(ProcessInformation.hProcess);  */
  TheProcHdl = ProcessInformation.hProcess;
  //debug
  /*tempastr=""; tempastr.sprintf("TheProcHdl==%d",
    TheProcHdl);
  log(tempastr);   */
  //end debug
  //SleepEx(20000, TRUE);
  //WaitForInputIdle(TheProcHdl, 20000);
  wfsoRet = ::WaitForSingleObject(TheProcHdl, 20000);
  //debug
  /*tempastr=""; tempastr.sprintf("wfsoRet==%d",
    wfsoRet);
  log(tempastr); */
  //end debug
  if (wfsoRet==WAIT_TIMEOUT)
  {
    log("wfsoRet==WAIT_TIMEOUT");
    ::TerminateProcess(TheProcHdl, 0);
    not_failed=false;
  }
  if (wfsoRet==WAIT_FAILED)
  {
    log("wfsoRet==WAIT_FAILED");
    not_failed=false;
  }
  ::CloseHandle(TheProcHdl);
  if (::GetFileSize(stderrFile, NULL)!=0)
   { log("stderrFile has size != 0"); not_failed=false; }
  ::CloseHandle(stdinFile);
  ::CloseHandle(stderrFile);
/*  ::CloseHandle(stdoutFile);
  OFSTRUCT ReOpenBuff;
  ReOpenBuff.cBytes = sizeof(ReOpenBuff);
  ReOpenBuff.fFixedDisk = 1;
  wsprintf(ReOpenBuff.szPathName, "%s", TempStdoutFile);
  stdoutFile = OpenFile(
    TempStdoutFile,	// pointer to filename
    &ReOpenBuff,	// pointer to buffer for file information
    OF_READ | OF_SHARE_DENY_WRITE // action and attributes
   );
  if (stdoutFile==HFILE_ERROR)
  {
    log("stdoutFile==HFILE_ERROR");
    not_failed=false;
  }  */
  //::DeleteFile(TempStdinFile);
  //::DeleteFile(TempStderrFile);
  if (not_failed)
  {//search for responce headers end to find responce body size
    bool waslf, islf=false;
    DWORD Test_SFP;
    LONG FLen, FHiPos;
    FLen = ::GetFileSize(stdoutFile, NULL);
    FHiPos=0;
    Test_SFP = ::SetFilePointer(stdoutFile, 0, &FHiPos, FILE_BEGIN);
            //debug
            /*tempastr=""; tempastr.sprintf("Test_SFP==%d\nFLen==%d",
              Test_SFP, FLen);
            log(tempastr);  */
            //end debug
    if (Test_SFP==0xFFFFFFFF)
    {
      LPVOID lpMsgBuf;
      FormatMessage(
        FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,
        NULL,
        GetLastError(),
        MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
        (LPTSTR) &lpMsgBuf,
        0,
        NULL
      );
      tempastr = (char*)lpMsgBuf;
      log(tempastr);
      LocalFree(lpMsgBuf);
    }//end (Test_SFP==0xFFFFFFFF)
    i=0; not_failed=false;
    do
    {
        IsReadOk = ::ReadFile(
            stdoutFile,
            &cchar,
            0x1,
            &BytesRead,
            NULL);
        //debug
        /*tempastr=""; tempastr.sprintf("IsReadOk==%d", IsReadOk);
        log(tempastr);   */
        //end debug
        if (IsReadOk)
        {
            //debug
            /*tempastr=""; tempastr.sprintf("BytesRead==%d", BytesRead);
            log(tempastr);
            log("IsReadOk==TRUE");  */
            //end debug
            if ((BytesRead!=0)&&(cchar!='\r'))
            {
                waslf = islf;
                islf = (cchar=='\n');
                if (waslf && islf) //reach end of HTTP headers
                 { BytesRead=0; not_failed=true; }
            }
        }
        else
          { BytesRead=0; /*not_failed=false;*/ }
        i++;
    } while((BytesRead!=0)&&(i<10000));
    if (not_failed)
    {
        log("not_failed==true before GetFileSize");
        bodysz = ::GetFileSize(stdoutFile, NULL);
        not_failed = (bodysz!=0xFFFFFFFF);
        bodysz -= i;
        if (bodysz<0) not_failed=false;
    }
  }
  //debug
  /*log("ending RunCGI");
  tempastr=""; tempastr.sprintf("bodysz==%d\ni==%d\nsize of file==%d",
    bodysz, i, ::GetFileSize(stdoutFile, NULL));
  log(tempastr);  */
  //end debug
  if (not_failed)
  {//call was OK
    //log("not_failed==true");
    AnsiString ObjBufOfHdrs;
    char BufOfHdrs[10001];
    int PosBufOfHdrs;
    ::SetFilePointer(stdoutFile, 0, NULL, FILE_BEGIN);
    IsReadOk = ::ReadFile(
            stdoutFile,
            BufOfHdrs,
            i,
            &BytesRead,
            NULL);
    if (IsReadOk && (i==(int)BytesRead))
    {
      BufOfHdrs[BytesRead] = '\0';
      ObjBufOfHdrs = BufOfHdrs;
      ObjBufOfHdrs = ObjBufOfHdrs.LowerCase();
      PosBufOfHdrs = ObjBufOfHdrs.Pos((AnsiString)"location:");
      if (PosBufOfHdrs>0)
      { p->Error = 301; }
    }
    ::SetFilePointer(stdoutFile, 0, NULL, FILE_BEGIN);
    return (int)stdoutFile;
  }
  else
  {//there was some error
     //log("not_failed==false");
     ::CloseHandle(stdoutFile);
     bodysz=-1; return (int)INVALID_HANDLE_VALUE;
  }
/*#undef BytesRead
#undef IsReadOk
#undef not_failed  */
}//end TForm1::RunCGI
//---------

AnsiString __fastcall TForm1::HTTPDecode(AnsiString AStr)
{
    //TODO: Add your source code here
    unsigned char *ptr, ch;
    int len, i, ccode;
    AnsiString ret, escBuf;
    //bool EscBeg=false;
    ptr = (unsigned char*)AStr.c_str();  len = AStr.Length();
    for (i=0; i<len; i++)
    {
        if (ptr[i]=='+') ch = ' ';
        else
        {
            if (ptr[i]=='%')
            {
                if ((i+1<len)&&(ptr[i+1]=='%'))
                 { ch = '%'; i++; }
                else
                {
                    if (i+2<len)
                    {
                        escBuf = AStr.SubString(i+2, 2);
                        if (sscanf(escBuf.c_str(), "%x", &ccode)==1)
                            ch = (unsigned char)ccode;
                        /*ch = (unsigned char)((((int)ptr[i+1]-48)<<4)+
                            ((int)ptr[i+2]-48));*/
                        i += 2;
                    }
                }
            }
            else
                ch = ptr[i];
        }
        ret.sprintf("%c", ch);
    }
    return ret;
}//end TForm1::HTTPDecode
//-------


bool __fastcall TForm1::RecognizeCGI(mParser* p)
{
    //TODO: Add your source code here
    AnsiString tmp;
    bool ret=false;
    tmp = ExtractFileExt(p->LocalPath);
    if (!tmp.IsEmpty())
    {
        tmp = tmp.SubString(2, tmp.Length()-1); //remove point
        tmp = tmp.LowerCase();
    }
    if (!tmp.IsEmpty())
    {
        int i, L, extPos, colonPos;
        AnsiString assoc_scr;
        bool ext_ok;
        char ch;
        L = CGIAssociations->Count;
        for (i=0; (!ret)&&(i<L); i++)
        {
          assoc_scr = CGIAssociations->Strings[i];
          colonPos = assoc_scr.Pos(":");
          if (colonPos>0)
          {
            extPos = assoc_scr.Pos(tmp);
            if ((extPos>0)&&(extPos<colonPos))
            {
              // first, check beginning
              if (extPos==1)
                ext_ok = true;
              else
              {
                ch = assoc_scr[extPos-1];
                ext_ok = (ch==' ') || (ch==',') || (ch==';');
              }
              ch = assoc_scr[extPos+tmp.Length()];
              ext_ok = ext_ok && ( (ch==' ') || (ch==',') ||
                (ch==';') || (ch==':') );
              if (ext_ok)
              {
                p->ExeApp = assoc_scr.SubString(colonPos+1,
                    assoc_scr.Length()-colonPos);
                if (!p->ExeApp.IsEmpty())
                    ret = true;
              }
            }//end if ((extPos>0)&&(extPos<colonPos))
          }//end if (colonPos>0)
        }//end for
    }
    if (!ret)
    {
        if (tmp=="exe") { ret=true; p->CGIType = CGITYPE_EXE; }
    }
    return ret;
}//end TForm1::RecognizeCGI
//--------


bool __fastcall TForm1::CheckFilename(AnsiString path)
{
    //TODO: Add your source code here
    if (DeniePointAtFirst)
    {
        AnsiString fname;
        fname = ExtractFileName(path);
        if (fname.IsEmpty())
            return true;
        else
            return (fname[1]!='.');
    }
    else
        return true;
}//end TForm1::CheckFilename
//--------

AnsiString __fastcall TForm1::ResolveExtra(AnsiString extra, mParser* p)
{
    //TODO: Add your source code here
    AnsiString ret;
    int i, len;
    unsigned char c, *ptr;
    len = extra.Length();
    ptr = (unsigned char*)extra.c_str();
    if ((ptr[0]=='\/')||(ptr[0]=='\\'))
        ret = RootCatalog;
    else
        ret = ExtractFilePath(p->LocalPath);
    for (i=0; i<len; i++)
    {
        c = ptr[i];
        if (c=='\/') c = '\\';
        ret.sprintf("%c", c);
    }//end for
    return ret;
}//end TForm1::ResolveExtra
//-----

AnsiString __fastcall TForm1::LoadAstr(AnsiString fname)
{
    //TODO: Add your source code here
    int fHandle, fSize, rSize;
    char *buf;
    AnsiString str;
    if (! FileExists(fname))
      return "";
    try
    {
      fHandle=FileOpen(fname,
        fmOpenRead);
      fSize=FileSeek(fHandle, 0, 2);
      FileSeek(fHandle, 0, 0);
      buf=new char[fSize+1];
      rSize=FileRead(fHandle, buf, fSize);
      buf[rSize]=0;
      str=(AnsiString)buf;
      delete [] buf;
      FileClose(fHandle);
    }
    catch (Exception &exception)
    {
      Form1->log(fname+" cannot be read!");
    }
    return str;
}//end TForm1::LoadAstr
//----------------

bool __fastcall TForm1::IsItURL(AnsiString str)
{
  bool rslt=false, is1, is2;
  AnsiString partHttp, partHttpS;
  is1 = (str.Length() > 7);
  if (is1)
  {
    partHttp = str.SubString(1, 7);
    partHttpS = str.SubString(1, 8);
    //log("DEBUG: partHttp = '"+partHttp+"'");
    partHttp = partHttp.LowerCase();
    partHttpS = partHttpS.LowerCase();
    is2 = (partHttp=="http://") || (partHttpS=="https://");
    if (is2) rslt=true;
  }
  return rslt;
}//end TForm1::IsItURL
//-------------------

void TForm1::LoadFromRegistry(void)
{
    //TODO: Add your source code here
    TRegistry *Registry;
    Registry = new TRegistry();
    Registry->RootKey = HKEY_LOCAL_MACHINE;
    AnsiString Key, kv;
    int wiplen=0, cgiasslen=0, rootlistlen=0;
    int i;
    Key="Software\\Super-M\\Son hServer";
    if (Registry->KeyExists(Key))
    {
      try
      {
        Registry->OpenKeyReadOnly(Key);
        if (Registry->ValueExists("RC"))
          RootCatalog = Registry->ReadString("RC");
        if (Registry->ValueExists("LS"))
          LogSessions = Registry->ReadBool("LS");
        if (Registry->ValueExists("LC"))
          LogConnects = Registry->ReadBool("LC");
        if (Registry->ValueExists("LF"))
          LogFiles = Registry->ReadBool("LF");
        if (Registry->ValueExists("LH"))
          LogHeaders = Registry->ReadBool("LH");
        if (Registry->ValueExists("L"))
          Lang = Registry->ReadInteger("L");
        if (Registry->ValueExists("SRS"))
          ShowRuntimeStatistics = Registry->ReadBool("SRS");
        if (Registry->ValueExists("SCC"))
          ShowCatalogContents = Registry->ReadBool("SCC");
        if (Registry->ValueExists("HOS"))
          HideOnStart = Registry->ReadBool("HOS");
        if (Registry->ValueExists("LD"))
          LogDebug = Registry->ReadBool("LD");
        if (Registry->ValueExists("LRH"))
          LogRemoteHosts = Registry->ReadBool("LRH");
        if (Registry->ValueExists("UIPF"))
          UseIPFiltering = Registry->ReadBool("UIPF");
        if (Registry->ValueExists("WrongIPListLen"))
          wiplen = Registry->ReadInteger("WrongIPListLen");
        if (Registry->ValueExists("SSH"))
          SendServerHeader = Registry->ReadBool("SSH");
        if (Registry->ValueExists("ICURL"))
          IndexCssURL = Registry->ReadString("ICURL");
        if (Registry->ValueExists("CGID"))
          CGIDir = Registry->ReadString("CGID");
        if (Registry->ValueExists("ECGI"))
          EnableCGI = Registry->ReadBool("ECGI");
        if (Registry->ValueExists("USCGIF"))
          UseSepCGIFolder = Registry->ReadBool("USCGIF");
        if (Registry->ValueExists("SCGIF"))
          SeparateCGIFolder = Registry->ReadString("SCGIF");
        if (Registry->ValueExists("DNICGI"))
          DenieNonprogramsInCGI = Registry->ReadBool("DNICGI");
        if (Registry->ValueExists("DPAF"))
          DeniePointAtFirst = Registry->ReadBool("DPAF");
        if (Registry->ValueExists("AEASC"))
          AllErrorsAsStatusCodes = Registry->ReadBool("AEASC");
        if (Registry->ValueExists("DIPIV"))
          DuplicateIPInVar = Registry->ReadBool("DIPIV");
        if (Registry->ValueExists("DIPV"))
          DuplicateIPVar = Registry->ReadString("DIPV");
        if (Registry->ValueExists("EP404"))
          ErrorFile404 = Registry->ReadString("EP404");
        if (Registry->ValueExists("EP500"))
          ErrorFile500 = Registry->ReadString("EP500");
        if (Registry->ValueExists("EP403"))
          ErrorFile403 = Registry->ReadString("EP403");
        if (Registry->ValueExists("KLOE"))
          KillLogOnExit = Registry->ReadBool("KLOE");
        if (Registry->ValueExists("U403"))
          Use403 = Registry->ReadBool("U403");
        if (Registry->ValueExists("CGIAssocListLen"))
          cgiasslen = Registry->ReadInteger("CGIAssocListLen");
        if (Registry->ValueExists("RootListLen"))
          rootlistlen = Registry->ReadInteger("RootListLen");
        Registry->CloseKey();
        if ( (wiplen>0) && Registry->KeyExists(Key+"\\WrongIPs") )
        {
            Registry->OpenKeyReadOnly(Key+"\\WrongIPs");
            for (i=0; i<wiplen; i++)
            {
              kv = ConcatStrNum("IP",i);
              if (Registry->ValueExists(kv))
                IPFilters->Add(Registry->ReadString(kv));
            }
            Registry->CloseKey();
        }
        if ( (cgiasslen>0) && Registry->KeyExists(Key+"\\CGIAssoc") )
        {
            Registry->OpenKeyReadOnly(Key+"\\CGIAssoc");
            for (i=0; i<cgiasslen; i++)
            {
              kv = ConcatStrNum("CGI",i);
              if (Registry->ValueExists(kv))
                CGIAssociations->Add(Registry->ReadString(kv));
            }
            Registry->CloseKey();
        }
        if ( (rootlistlen>0) && Registry->KeyExists(Key+"\\Roots") )
        {
            Registry->OpenKeyReadOnly(Key+"\\Roots");
            for (i=0; i<rootlistlen; i++)
            {
              kv = ConcatStrNum("Root",i);
              if (Registry->ValueExists(kv))
                RootList->Add(Registry->ReadString(kv));
            }
            Registry->CloseKey();
        }
      }//end try
      catch (...)
      {
       Application->MessageBox(
        ",   \n"
        "     ",
        "   ",
        MB_OK | MB_ICONERROR);
      }
    }//end if
    delete Registry;
}//end TForm1::LoadFromRegistry
//---------------------------------------
