//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ScktComp.hpp>
#include <Filectrl.hpp>
#include <ExtCtrls.hpp>
#include <Buttons.hpp>
#include <Registry.hpp>
#include "TrayComp.h"
#include <Menus.hpp>
#include <IniFiles.hpp>
//#include <HTTPApp.hpp>
//-----------------------------------

enum resp_type
{
    RESPONCE_TEXT,
    RESPONCE_FILE,
    RESPONCE_REDIR
};

//------------
class mParser
{
public:
    TCustomWinSocket* sock;
    AnsiString IP, Port;
    TDateTime lasttime;
    bool ProcessingRead, MustStop, Broken;
    AnsiString Head, Body;
    bool HeadDone, BodyDone, NowLF, InCGIDir, IsCGI;
    int BodyLength, BodyPos, HeadPos, EnvVarsSize;
    TStringList* Headers;
    int Error, NOpenStreams, CGIType;
    AnsiString HTTPMethod, URI, HTTPVersion, LastModif;
    AnsiString LocalPath, QueryString, ExeApp;
    int HTTPMinorV;
    AnsiString FileURL;
    mParser(void);
    ~mParser(void);
};
//-------
class mParserList
{
public:
    mParser **list;
    int N;
    mParserList(void);
    ~mParserList(void);
    mParser* Add(TCustomWinSocket* s);
    void Remove(TCustomWinSocket* s);
    mParser* Get(TCustomWinSocket* s);
};
//----------------------------------------

class mAutocloseStream : public THandleStream
{
public:
    __fastcall mAutocloseStream(int AHandle)/* : THandleStream(AHandle) {}*/;
    __fastcall ~mAutocloseStream(void);
};

class mFileStreams
{
private:
    TFileStream **list;
    mParser **plist;
    int N;
public:
    mFileStreams(void);
    ~mFileStreams(void);
    TFileStream* Add(AnsiString fnm, mParser* p);
    void Delete(int num);
    void Refresh(void);
};
//------------------
class TForm1 : public TForm
{
__published:	// IDE-managed Components
    TServerSocket *ServerSocket1;
    TTimer *Timer1;
    TLabel *Label1;
    TComboBox *LangComboBox;
    TButton *OptionsButton;
    TBitBtn *AboutBtn;
    TLabel *Label2;
    TLabel *StatLabel1;
    TLabel *StatLabel2;
    TTrayComp *TrayComp1;
    TPopupMenu *PopupMenu1;
    TMenuItem *Restore;
    TMenuItem *Exit;
    TMenuItem *N1;
    TButton *HideButton;
  TShape *IndicatorShape;
    void __fastcall ServerSocket1ClientDisconnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ServerSocket1ClientRead(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall ServerSocket1ClientError(TObject *Sender,
          TCustomWinSocket *Socket, TErrorEvent ErrorEvent,
          int &ErrorCode);
    void __fastcall ServerSocket1ClientConnect(TObject *Sender,
          TCustomWinSocket *Socket);
    void __fastcall Timer1Timer(TObject *Sender);
    void __fastcall LangComboBoxChange(TObject *Sender);
    void __fastcall OptionsButtonClick(TObject *Sender);
    void __fastcall AboutBtnClick(TObject *Sender);
    void __fastcall FormShow(TObject *Sender);
    void __fastcall RestoreClick(TObject *Sender);
    void __fastcall ExitClick(TObject *Sender);
    void __fastcall HideButtonClick(TObject *Sender);
private:	// User declarations
public:		// User declarations
    mParserList *ParserList;
    AnsiString logFileName, RootCatalog, IndexCssURL;
    bool LogSessions, LogConnects, LogFiles, LogHeaders;
    int SessionTotalConnects, SessionTotalRequests, SessionTotalErrors;
    int SessionTotalDeniedIPs;
    TStringList *MIMETypes;
    int Lang;
    bool ShowRuntimeStatistics, ShowCatalogContents, HideOnStart;
    bool LogDebug, LogRemoteHosts;
    TStringList *IPFilters;
    bool UseIPFiltering, SendServerHeader, EnableCGI;
    bool UseSepCGIFolder, DenieNonprogramsInCGI, DeniePointAtFirst;
    bool AllErrorsAsStatusCodes, DuplicateIPInVar;
    AnsiString CGIDir, SeparateCGIFolder, DuplicateIPVar;
    TStringList *CGIAssociations;
    TStringList *RootList;
    AnsiString ErrorFile404, ErrorFile500, ErrorFile403;
    bool KillLogOnExit;
    bool Use403;
    bool PreventSaveLangReg; //run-time preventer flag
    AnsiString IniFileName;
    bool IniFileExists;
//    TRegistry *Registry;
    __fastcall TForm1(TComponent* Owner);
    __fastcall ~TForm1(void);
    void log(AnsiString str);
    AnsiString getNow(void);
    void ParseBuf(mParser* p, char* buf, int bufLen);
    void ResetParser(mParser* p);
    void ParseHead(mParser* p);
    void DoResponse(mParser* p);
    AnsiString getHTTPHeader(mParser* p, AnsiString name);
    AnsiString ResolveToLocal(AnsiString uri, bool in_cgidir=false);
    AnsiString GetCatalogContents(AnsiString path);
    AnsiString ResolveToURI(AnsiString path, AnsiString f);
    AnsiString __fastcall GetMIMEType(AnsiString fname);
    bool FindCatalogIndex(AnsiString& path);
    void LoadReg(void);
    void SaveReg(void);
    void SaveLangReg(void);
    int ExtractHTTPVersion(AnsiString hvs);
    AnsiString GenHTTPDate(FILETIME& fdate);
    bool TestWrongIP(AnsiString& whatip, AnsiString& ipmask);
    AnsiString __fastcall ConcatStrNum(AnsiString str, int num);
    void __fastcall AppException(System::TObject* Sender, Sysutils::Exception* E);
    bool CheckCGIDir(AnsiString& thedir);
    int /*__fastcall*/ RunCGI(mParser* p, int& bodysz/*, bool& noerr*/);
    AnsiString __fastcall HTTPDecode(AnsiString AStr);
    bool __fastcall RecognizeCGI(mParser* p);
    bool __fastcall CheckFilename(AnsiString path);
    AnsiString __fastcall ResolveExtra(AnsiString extra, mParser* p);
    AnsiString __fastcall LoadAstr(AnsiString fname);
    bool __fastcall IsItURL(AnsiString str);
    void LoadFromRegistry(void);
};

//---------------------------------------------------------------------------
extern PACKAGE TForm1 *Form1;
//---------------------------------------------------------------------------
#endif

