//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Unit2.h"
#include "Unit1.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TOptionsForm *OptionsForm;
//-----------------------------------------

bool WrongCharInIP(AnsiString& ipstr, bool pureip);

//----------------------------------
__fastcall TOptionsForm::TOptionsForm(TComponent* Owner)
    : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TOptionsForm::CancelButtonClick(TObject *Sender)
{
    Close();    
}
//---------------------------------------------------------------------------
void __fastcall TOptionsForm::FormShow(TObject *Sender)
{
    RootPath->Text = Form1->RootCatalog;
    Language->ItemIndex = Form1->Lang;
    ShowStatCheckBox->Checked = Form1->ShowRuntimeStatistics;
    ShowCatContCheckBox->Checked = Form1->ShowCatalogContents;
    HideOnStartCheckBox->Checked = Form1->HideOnStart;
    LogSessionsCheckBox->Checked = Form1->LogSessions;
    LogConnectsCheckBox->Checked = Form1->LogConnects;
    LogFilesCheckBox->Checked = Form1->LogFiles;
    LogHeadersCheckBox->Checked = Form1->LogHeaders;
    LogDebugCheckBox->Checked = Form1->LogDebug;
    LogRemoteHostsCheckBox->Checked = Form1->LogRemoteHosts;
    UseIPFilteringCheckBox->Checked = Form1->UseIPFiltering;
    IPFiltersListBox->Items->Assign((TPersistent*)Form1->IPFilters);
    SendServerHeaderCheckBox->Checked = Form1->SendServerHeader;
    IndexCssURL->Text = Form1->IndexCssURL;
    ECGICheckBox->Checked = Form1->EnableCGI;
    CGIDir->Text = Form1->CGIDir;
    USCGIFCheckBox->Checked = Form1->UseSepCGIFolder;
    SeparateCGIFolder->Text = Form1->SeparateCGIFolder;
    DNICGICheckBox->Checked = Form1->DenieNonprogramsInCGI;
    DPAFCheckBox->Checked = Form1->DeniePointAtFirst;
    AEASCCheckBox->Checked = Form1->AllErrorsAsStatusCodes;
    DIPIVCheckBox->Checked = Form1->DuplicateIPInVar;
    DuplicateIPVar->Text = Form1->DuplicateIPVar;
    CGIAssocListBox->Items->Assign((TPersistent*)Form1->CGIAssociations);
    UpdtIPFiltersCtrls();
    ShowCatContCheckBoxClick(Sender);
    ECGICheckBoxClick(Sender);
    DIPIVCheckBoxClick(Sender);
    CheckBox403Click(Sender);
    ListBoxRoots->Items->Assign((TPersistent*)Form1->RootList);
    File404Edit->Text = Form1->ErrorFile404;
    File500Edit->Text = Form1->ErrorFile500;
    File403Edit->Text = Form1->ErrorFile403;
    KLOECheckBox->Checked = Form1->KillLogOnExit;
    CheckBox403->Checked = Form1->Use403;
}//end TOptionsForm::FormShow
//---------------------------------------------------------------------------
void __fastcall TOptionsForm::OKButtonClick(TObject *Sender)
{
    int L;
    bool LangChanged;
    // Verify RootPath
    L = RootPath->Text.Length();
    if (L==0) { RootPath->Text="C:";  L = RootPath->Text.Length(); }
    if (RootPath->Text[L]=='\\')
        RootPath->Text = RootPath->Text.SubString(1, L-1);
    if (! DirectoryExists(RootPath->Text))
    {
        char *mcapt, *mtext;
        switch (Form1->Lang)
        {
        case 0: //ru
            mcapt = "  ";
            mtext = "   !";
        break;
        case 2: //by
            mcapt = "² ͨ ";
            mtext = "   !";
        break;
        case 3: //srb
            mcapt = "  ȣ";
            mtext = "   !";
        break;
        case 4: //ua
            mcapt = "  ";
            mtext = "   !";
        break;
        case 5: //bg
            mcapt = " ";
            mtext = "    !";
        break;
        default: //en
            mcapt = "WRONG ROOT PATH";
            mtext = "Specified path must exist!";
        }//end switch
        PageControl1->ActivePage = TabSheet1;
        if (RootPath->CanFocus()) RootPath->SetFocus();
        Application->MessageBox(mtext, mcapt,
            MB_OK | MB_ICONWARNING);
        return;
    }//end if
    // Verify SeparateCGIFolder
    L = SeparateCGIFolder->Text.Length();
    if (L==0)
     { SeparateCGIFolder->Text="C:";  L = SeparateCGIFolder->Text.Length(); }
    if (SeparateCGIFolder->Text[L]=='\\')
        SeparateCGIFolder->Text = SeparateCGIFolder->Text.SubString(1, L-1);
    if (! DirectoryExists(SeparateCGIFolder->Text))
    {
        char *mcapt, *mtext;
        switch (Form1->Lang)
        {
        case 0: //ru
            mcapt = "   CGI ";
            mtext = "   !";
        break;
        case 2: //by
            mcapt = "    CGI";
            mtext = "   !";
        break;
        case 3: //srb
            mcapt = "    ȣ";
            mtext = "   !";
        break;
        case 4: //ua
            mcapt = "²   CGI ";
            mtext = "   !";
        break;
        case 5: //bg
            mcapt = "   CGI ";
            mtext = "    !";
        break;
        default: //en
            mcapt = "WRONG FOLDER FOR CGI DIR";
            mtext = "Specified path must exist!";
        }//end switch
        PageControl1->ActivePage = TabSheet4;
        if (SeparateCGIFolder->CanFocus()) SeparateCGIFolder->SetFocus();
        Application->MessageBox(mtext, mcapt,
            MB_OK | MB_ICONWARNING);
        return;
    }//end if
    // Verify IndexCssURL
    if ( (IndexCssURL->Text.Pos("\\")!=0) ||
         (IndexCssURL->Text.Pos(":")==2) )
    {
        char *mcapt, *mtext;
        switch (Form1->Lang)
        {
        case 0: //ru
            mcapt = " URL CSS-  -";
            mtext = "        URL!\n"
                "URL    .\n"
                "   .";
        break;
        case 2: //by
            mcapt = "² URL CSS-  -";
            mtext = "        URL!\n"
                "URL    .\n"
                "   .";
        break;
        case 3: //srb
            mcapt = "Ŏ      ";
            mtext = "       !\n"
                "    .\n"
                "   .";
        break;
        case 4: //ua
            mcapt = "² URL CSS-  -в";
            mtext = "        URL!\n"
                "URL    .\n"
                "   .";
        break;
        case 5: //bg
            mcapt = " URL   CSS    ";
            mtext = "        URL !\n"
                "URL     .\n"
                ",    .";
        break;
        default: //en
            mcapt = "WRONG URL OF CSS-FILE FOR INDEX-PAGES";
            mtext = "You cannot enter local file paths in this URL!\n"
                "The URL should be an INTERNET ADDRESS.\n"
                "Please read USER`S MANUAL.";
        }//end switch
        PageControl1->ActivePage = TabSheet1;
        if (IndexCssURL->CanFocus()) IndexCssURL->SetFocus();
        Application->MessageBox(mtext, mcapt,
            MB_OK | MB_ICONWARNING);
        return;
    }
    // Verify DuplicateIPVar
    if (DIPIVCheckBox->Checked)
    {
      AnsiString dupipv_tmp;
      dupipv_tmp = DuplicateIPVar->Text;
      if (dupipv_tmp=="REMOTE_ADDR")
      {//check for REMOTE_ADDR
        char *mcapt, *mtext;
        switch (Form1->Lang)
        {
        case 0: //ru
            mcapt = " ";
            mtext = " REMOTE_ADDR    CGI\n"
                "    \n"
                ",   ";
        break;
        case 2: //by
            mcapt = "Ρ ";
            mtext = " REMOTE_ADDR    CGI\n"
                "  븢  \n"
                " ,   ";
        break;
        case 3: //srb
            mcapt = " ";
            mtext = "REMOTE_ADDR      CGI\n"
                "     \n"
                "    ";
        break;
        case 4: //ua
            mcapt = " ";
            mtext = " REMOTE_ADDR    CGI\n"
                "    \n"
                " ,   ";
        break;
        case 5: //bg
            mcapt = " ";
            mtext = " REMOTE_ADDR     CGI\n"
                "     \n"
                ",   ";
        break;
        default: //en
            mcapt = "SENSELESS OPTION";
            mtext = "Variable REMOTE_ADDR is always set for CGI\n"
                "No need in setting it manually\n"
                "Please uncheck this option";
        }//end switch
        PageControl1->ActivePage = TabSheet5;
        if (DIPIVCheckBox->CanFocus()) DIPIVCheckBox->SetFocus();
        Application->MessageBox(mtext, mcapt,
            MB_OK | MB_ICONWARNING);
        return;
      }
      if (dupipv_tmp.Pos("=")>0)
      {//check for =
        char *mcapt, *mtext;
        switch (Form1->Lang)
        {
        case 0: //ru
            mcapt = "   ";
            mtext = "      '='";
        break;
        case 2: //by
            mcapt = "²   ";
            mtext = "      '='";
        break;
        case 3: //srb
            mcapt = "  ͊ Ō";
            mtext = "       '='";
        break;
        case 4: //ua
            mcapt = " ' ̲ί ";
            mtext = "'      '='";
        break;
        case 5: //bg
            mcapt = "    ";
            mtext = "        '='";
        break;
        default: //en
            mcapt = "WRONG ENVIRONMENT VARIABLE NAME";
            mtext = "Variable name cannot contain '=' symbol";
        }//end switch
        PageControl1->ActivePage = TabSheet5;
        if (DuplicateIPVar->CanFocus()) DuplicateIPVar->SetFocus();
        Application->MessageBox(mtext, mcapt,
            MB_OK | MB_ICONWARNING);
        return;
      }
      if ((dupipv_tmp.Length()<5)||(dupipv_tmp.SubString(1,5)!="HTTP_"))
      {//check for HTTP_ prefix
        char *mtext;
        switch (Form1->Lang)
        {
        case 0: //ru
            mtext = "   \n"
                "  HTTP_\n"
                "( , HTTP_X_MY_VARIABLE )\n"
                "   - .   ?";
        break;
        case 2: //by
            mtext = "   \n"
                "  HTTP_\n"
                "(, HTTP_X_MY_VARIABLE)\n"
                "   - .   ?";
        break;
        case 3: //srb
            mtext = "    \n"
                "  HTTP_\n"
                "( . HTTP_X_MY_VARIABLE )\n"
                "  .   ?";
        break;
        case 4: //ua
            mtext = "  ' \n"
                "  HTTP_\n"
                "(, HTTP_X_MY_VARIABLE)\n"
                "   - .   ?";
        break;
        case 5: //bg
            mtext = "    \n"
                "   HTTP_\n"
                "(. HTTP_X_MY_VARIABLE)\n"
                "  - .    ?";
        break;
        default: //en
            mtext = "It`s recommended for variable name\n"
                "to begin with HTTP_ prefix\n"
                "( e.g., HTTP_X_MY_VARIABLE )\n"
                "Your variable don`t. Apply anyway?";
        }//end switch
        PageControl1->ActivePage = TabSheet5;
        if (DuplicateIPVar->CanFocus()) DuplicateIPVar->SetFocus();
        if (Application->MessageBox(mtext, dupipv_tmp.c_str(),
            MB_YESNO | MB_ICONQUESTION)==IDNO)
            return;
      }
    }//end if (DIPIVCheckBox->Checked)
    // Determine LangChanged
    LangChanged = (Form1->Lang != Language->ItemIndex);
    // Assign settings to corresponding Form1 parameters
    Form1->RootCatalog = RootPath->Text;
    Form1->Lang = Language->ItemIndex;
    Form1->ShowRuntimeStatistics = ShowStatCheckBox->Checked;
    Form1->ShowCatalogContents = ShowCatContCheckBox->Checked;
    Form1->HideOnStart = HideOnStartCheckBox->Checked;
    Form1->LogSessions = LogSessionsCheckBox->Checked;
    Form1->LogConnects = LogConnectsCheckBox->Checked;
    Form1->LogFiles = LogFilesCheckBox->Checked;
    Form1->LogHeaders = LogHeadersCheckBox->Checked;
    Form1->LogDebug = LogDebugCheckBox->Checked;
    Form1->LogRemoteHosts = LogRemoteHostsCheckBox->Checked;
    Form1->UseIPFiltering = UseIPFilteringCheckBox->Checked;
    Form1->IPFilters->Assign((TPersistent*)IPFiltersListBox->Items);
    Form1->SendServerHeader = SendServerHeaderCheckBox->Checked;
    Form1->IndexCssURL = IndexCssURL->Text;
    Form1->EnableCGI = ECGICheckBox->Checked;
    L = CGIDir->Text.Length();
    if (L>0)
    {
        if (CGIDir->Text[L]!='/')
            CGIDir->Text += "/";
        if (CGIDir->Text[1]!='/')
            CGIDir->Text = (AnsiString)"/"+CGIDir->Text;
    }
        else CGIDir->Text = "/";
    Form1->CGIDir = CGIDir->Text;
    Form1->UseSepCGIFolder = USCGIFCheckBox->Checked;
    Form1->SeparateCGIFolder = SeparateCGIFolder->Text;
    Form1->DenieNonprogramsInCGI = DNICGICheckBox->Checked;
    Form1->DeniePointAtFirst = DPAFCheckBox->Checked;
    Form1->AllErrorsAsStatusCodes = AEASCCheckBox->Checked;
    Form1->DuplicateIPInVar = DIPIVCheckBox->Checked;
    Form1->DuplicateIPVar = DuplicateIPVar->Text;
    Form1->CGIAssociations->Assign((TPersistent*)CGIAssocListBox->Items);
    Form1->RootList->Assign((TPersistent*)ListBoxRoots->Items);
    Form1->ErrorFile404 = File404Edit->Text;
    Form1->ErrorFile500 = File500Edit->Text;
    Form1->ErrorFile403 = File403Edit->Text;
    Form1->KillLogOnExit = KLOECheckBox->Checked;
    Form1->Use403 = CheckBox403->Checked;
    // Save parameters in registry
    Form1->SaveReg();
    // Do some other needed actions
    if (! Form1->ShowRuntimeStatistics)
    {
        Form1->StatLabel1->Caption = "--";
        Form1->StatLabel2->Caption = "--";
    }
    if (LangChanged)
    {
        Form1->LangComboBox->ItemIndex = Form1->Lang;
        Form1->PreventSaveLangReg = true;
        Form1->LangComboBoxChange(this);
    }
    Close();
}//end TOptionsForm::OKButtonClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::TestipfiltButtonClick(TObject *Sender)
{
    AnsiString fakeip, fakefilt;
    InputQuery("enter [fake] IP", "", fakeip);
    if (WrongCharInIP(fakeip, true))
    {
        Application->MessageBox("This is not a valid"
            " [fake] IP", "Can`t test",
            MB_OK | MB_ICONWARNING);
        return;
    }
    InputQuery("enter [fake] IP filtering mask", "", fakefilt);
    if (WrongCharInIP(fakefilt, false))
    {
        Application->MessageBox("Wrong characters found in this"
            " [fake] IP range", "Can`t test",
            MB_OK | MB_ICONWARNING);
        return;
    }
    if (Form1->TestWrongIP(fakeip, fakefilt))
        Application->MessageBox("TForm1::TestWrongIP()==true"
            " (denied IP)", "Test result",
            MB_OK | MB_ICONINFORMATION);
    else
        Application->MessageBox("TForm1::TestWrongIP()==false"
            " (allowed IP)", "Test result",
            MB_OK | MB_ICONINFORMATION);
}//end TOptionsForm::TestipfiltButtonClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::IPFilterAddClick(TObject *Sender)
{
    AnsiString tmp;
    char *qcapt, *qtext, *warncapt, *warntext;
    bool queryOK, wrongSymbDet;
    switch (Form1->Lang)
    {
    case 0: //ru
        qcapt = "  IP";
        qtext = "  IP-:";
        warntext = "   () ()\n"
              "(,   - ).\n"
              ",   .";
        warncapt = "    !";
    break;
    case 2: //by
        qcapt = "  IP";
        qtext = "  IP-:";
        warntext = "   ()  ()\n"
              "(,   - ).\n"
              " ,  .";
        warncapt = "    !";
    break;
    case 3: //srb
        qcapt = " IP ";
        qtext = "  IP :";
        warntext = "    ()  ()\n"
              "( ,    .)\n"
              " ,   .";
        warncapt = "    !";
    break;
    case 4: //ua
        qcapt = "  IP";
        qtext = "  IP-:";
        warntext = "   () ()\n"
              "(,    ).\n"
              " ,   .";
        warncapt = "    !";
    break;
    case 5: //bg
        qcapt = "  IP ";
        qtext = "   IP :";
        warntext = "   ()  ()\n"
              "(,    ).\n"
              ",   .";
        warncapt = "     !";
    break;
    default: //en
        qcapt = "Adding an IP range";
        qtext = "Specify IP address mask:";
        warntext = "Non-acceptable symbol(s) present in mask\n"
              "(e.g. Space or something other).\n"
              "Please delete all of those.";
        warncapt = "Can`t accept this mask!";
    }//end switch
    do
    {
        queryOK = InputQuery(qcapt, qtext, tmp);
        wrongSymbDet = WrongCharInIP(tmp, false);
        if (queryOK && wrongSymbDet)
          Application->MessageBox(
            warntext,
            warncapt,
            MB_OK | MB_ICONWARNING);
    } while (queryOK && wrongSymbDet);
    if (queryOK)
        IPFiltersListBox->Items->Add(tmp);
}//end TOptionsForm::IPFilterAddClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::IPFilterRemoveClick(TObject *Sender)
{
    int itind;
    char *wcapt, *wtext;
    itind=IPFiltersListBox->ItemIndex;
    if (itind==-1)
    {
      switch (Form1->Lang)
      {
      case 0: //Ru
        wcapt = " ,  ";
        wtext = "     !";
      break;
      case 2: //By
        wcapt = " ,  ";
        wtext = "     !";
      break;
      case 3: //Srb
        wcapt = "    ";
        wtext = "    !";
      break;
      case 4: //Ua
        wcapt = " ,  ";
        wtext = "    !";
      break;
      case 5: //Bg
        wcapt = "    ";
        wtext = "      !";
      break;
      default: //En
        wcapt = "I don't know what to remove";
        wtext = "No one of ranges is selected!";
      }
      Application->MessageBox(wtext, wcapt,
        MB_OK | MB_ICONWARNING);
    }
    else
        IPFiltersListBox->Items->Delete(itind);
}//end TOptionsForm::IPFilterRemoveClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::IPFiltersClearClick(TObject *Sender)
{
    char *wcapt, *wtext;
    if (IPFiltersListBox->Items->Count==0)
    {
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " !";
        wtext = "  IP ";
      break;
      case 2: //by
        wcapt = "  !";
        wtext = "  IP ";
      break;
      case 3: //srb
        wcapt = "  !";
        wtext = "    ";
      break;
      case 4: //ua
        wcapt = "ͳ !";
        wtext = "  IP ";
      break;
      case 5: //bg
        wcapt = "   !";
        wtext = "  IP   ";
      break;
      default: //en
        wcapt = "There`s no thing to remove!";
        wtext = "IP ranges list is empty";
      }
      Application->MessageBox(wtext, wcapt,
        MB_OK | MB_ICONWARNING);
    }
    else
    {
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " ";
        wtext = "    "
            "!\n ?";
      break;
      case 2: //by
        wcapt = " ";
        wtext = "    "
            "!\n ?";
      break;
      case 3: //srb
        wcapt = " ";
        wtext = "     "
            "!\n ?";
      break;
      case 4: //ua
        wcapt = " ";
        wtext = "    "
            "!\n ?";
      break;
      case 5: //bg
        wcapt = "  ";
        wtext = "     "
            "!\n  ?";
      break;
      default: //en
        wcapt = "Clearing the list";
        wtext = "All ranges shown will be removed!\n"
            "Do You confirm?";
      }
      if ( Application->MessageBox(wtext, wcapt,
            MB_YESNO | MB_ICONQUESTION)==IDYES )
          IPFiltersListBox->Items->Clear();
    }
}//end TOptionsForm::IPFiltersClearClick
//-------------------------------------


void __fastcall TOptionsForm::UpdtIPFiltersCtrls(void)
{
    //TODO: Add your source code here
    bool ipfon=UseIPFilteringCheckBox->Checked;
    IPFiltersListBox->Color = ipfon?clWindow:clBtnFace;
    IPFiltersListBox->Enabled = ipfon;
    IPFilterAdd->Enabled = ipfon;
    IPFilterEdit->Enabled = ipfon;
    IPFilterRemove->Enabled = ipfon;
    IPFiltersClear->Enabled = ipfon;
}
//--------------------------------------
void __fastcall TOptionsForm::UseIPFilteringCheckBoxClick(TObject *Sender)
{
    UpdtIPFiltersCtrls();    
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::IPFilterEditClick(TObject *Sender)
{
    int itind;
    char *wcapt, *wtext;
    itind=IPFiltersListBox->ItemIndex;
    if (itind==-1)
    {
      //message if no range selected
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " -?";
        wtext = "     !";
      break;
      case 2: //by
        wcapt = " -?";
        wtext = "     !";
      break;
      case 3: //srb
        wcapt = "   ?";
        wtext = "    !";
      break;
      case 4: //ua
        wcapt = " -?";
        wtext = "    !";
      break;
      case 5: //bg
        wcapt = "  ?";
        wtext = "      !";
      break;
      default: //en
        wcapt = "What to edit?";
        wtext = "No one of ranges is selected!";
      }
      Application->MessageBox(wtext, wcapt,
        MB_OK | MB_ICONWARNING);
    }
    else
    {
        AnsiString tmp;
        char *qcapt, *qtext, *warncapt, *warntext;
        bool queryOK, wrongSymbDet;
        switch (Form1->Lang)
        {
        case 0: //ru
            qcapt = "  IP";
            qtext = "  IP-:";
            warntext = "   () ()\n"
              "(,   - ).\n"
              ",   .";
            warncapt = "    !";
        break;
        case 2: //by
            qcapt = "  IP";
            qtext = "  IP-:";
            warntext = "   ()  ()\n"
              "(,   - ).\n"
              " ,  .";
            warncapt = "    !";
        break;
        case 3: //srb
            qcapt = "  ";
            qtext = "   :";
            warntext = "    ()  ()\n"
              "( ,    .)\n"
              " ,   .";
            warncapt = "    !";
        break;
        case 4: //ua
            qcapt = "  IP";
            qtext = "³  IP-:";
            warntext = "   () ()\n"
              "(,    ).\n"
              " ,   .";
            warncapt = "    !";
        break;
        case 5: //bg
            qcapt = "  IP ";
            qtext = "   IP :";
            warntext = "   ()  ()\n"
              "(,    ).\n"
              ",   .";
            warncapt = "     !";
        break;
        default: //en
            qcapt = "Editing an IP range";
            qtext = "Change IP address mask:";
            warntext = "Non-acceptable symbol(s) present in mask\n"
              "(e.g. Space or something other).\n"
              "Please delete all of those.";
            warncapt = "Can`t accept this mask!";
        }
        tmp = IPFiltersListBox->Items->Strings[itind];
        do
        {
         queryOK = InputQuery(qcapt, qtext, tmp);
         wrongSymbDet = WrongCharInIP(tmp, false);
         if (queryOK && wrongSymbDet)
          Application->MessageBox(warntext, warncapt,
            MB_OK | MB_ICONWARNING);
        } while (queryOK && wrongSymbDet);
        if (queryOK)
            IPFiltersListBox->Items->Strings[itind] = tmp;
    }
}//end TOptionsForm::IPFilterEditClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::IPFiltersListBoxDblClick(TObject *Sender)
{
    IPFilterEditClick(Sender);
}
//----------------------------------


bool WrongCharInIP(AnsiString& ipstr, bool pureip)
{//check for wrong char in IP or IP range
    bool ret=false;
    char *ptr, ch;
    int len;
    ptr = ipstr.c_str();  len = ipstr.Length();
    for (int i=0; (!ret)&&(i<len); i++)
    {
        ch = ptr[i];
        switch (ch)
        {
        case '.': break;
        case '-':
        case '*': ret = ret || pureip; break;
        default:
            ret = ret || (ch<'0') || (ch>'9');
        }//end switch
    }
    return ret;
}//end WrongCharInIP
//-----------------------------------------

void __fastcall TOptionsForm::ShowCatContCheckBoxClick(TObject *Sender)
{
    bool ono=ShowCatContCheckBox->Checked;
    IndexCssURL->Color = ono?clWindow:clBtnFace;
    IndexCssURL->Enabled = ono;
}//end TOptionsForm::ShowCatContCheckBoxClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::RestoreDefCGIDirButtonClick(TObject *Sender)
{
    CGIDir->Text = "/cgi-bin/";
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::ECGICheckBoxClick(TObject *Sender)
{
    bool ono=ECGICheckBox->Checked;
    Label5->Enabled = ono;
    CGIDir->Color = ono?clWindow:clBtnFace;
    CGIDir->Enabled = ono;
    RestoreDefCGIDirButton->Enabled = ono;
    USCGIFCheckBox->Enabled = ono;
    DNICGICheckBox->Enabled = ono;
    CGIAssocGroupBox->Enabled = ono;
    CGIAssocListBox->Color = ono?clWindow:clBtnFace;
    if (ono)
        USCGIFCheckBoxClick(Sender);
    else
    {
        SeparateCGIFolder->Color = clBtnFace;
        SeparateCGIFolder->Enabled = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::USCGIFCheckBoxClick(TObject *Sender)
{
    bool ono=USCGIFCheckBox->Checked;
    SeparateCGIFolder->Color = ono?clWindow:clBtnFace;
    SeparateCGIFolder->Enabled = ono;
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::DIPIVCheckBoxClick(TObject *Sender)
{
    bool ono=DIPIVCheckBox->Checked;
    DuplicateIPVar->Color = ono?clWindow:clBtnFace;
    DuplicateIPVar->Enabled = ono;
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::CGIAssocAddClick(TObject *Sender)
{
    AnsiString exts, app;
    char *qcapt, *qtext;
    bool queryOK;
    switch (Form1->Lang)
    {
    case 0: //ru
        qcapt = " CGI ,  1";
        qtext = "  ( ):";
    break;
    case 2: //by
        qcapt = " CGI ,  1";
        qtext = "  ( ):";
    break;
    case 3: //srb
        qcapt = "  ,  1";
        qtext = "  ( ):";
    break;
    case 4: //ua
        qcapt = " CGI ,  1";
        qtext = "  ( ):";
    break;
    case 5: //bg
        qcapt = "  CGI ,  1";
        qtext = "  (  ):";
    break;
    default: //en
        qcapt = "Adding CGI association, step 1";
        qtext = "File extensions (comma-separated):";
    }
    queryOK = InputQuery(qcapt, qtext, exts);
    if (queryOK)
    {
      //setting an interpreter
      switch (Form1->Lang)
      {
      case 0: //ru
        qcapt = " CGI ,  2";
        qtext = " (  ) exe-:";
      break;
      case 2: //by
        qcapt = " CGI ,  2";
        qtext = " (  ) exe-:";
      break;
      case 3: //srb
        qcapt = "  ,  2";
        qtext = " (  )  :";
      break;
      case 4: //ua
        qcapt = " CGI ,  2";
        qtext = "' (  ) exe-:";
      break;
      case 5: //bg
        qcapt = "  CGI ,  2";
        qtext = " (  ) exe-app:";
      break;
      default: //en
        qcapt = "Adding CGI association, step 2";
        qtext = "A name (or a full path) of an exe-application:";
      }
      queryOK = InputQuery(qcapt, qtext, app);
    }
    if (queryOK)
    {
      if (exts.IsEmpty() || app.IsEmpty())
      {
        //message
        char *wcapt, *wtext;
        switch (Form1->Lang)
        {
        case 0: //ru
          wcapt = " !";
          wtext = "   \n"
            "  !";
        break;
        case 2: //by
          wcapt = " ˲˲!";
          wtext = "   \n"
            "  !";
        break;
        case 3: //srb
          wcapt = " !";
          wtext = "    \n"
            "  !";
        break;
        case 4: //ua
          wcapt = " !";
          wtext = "    \n"
            "  !";
        break;
        case 5: //bg
          wcapt = "!";
          wtext = "      \n"
            "   !";
        break;
        default: //en
          wcapt = "YOU`VE MADE A MISTAKE!";
          wtext = "Empty strings are not allowed\n"
            "Association has NOT been added!";
        }
        Application->MessageBox(wtext, wcapt,
          MB_OK | MB_ICONWARNING);
      }
      else
        CGIAssocListBox->Items->Add(exts+":"+app);
    }
}//end TOptionsForm::CGIAssocAddClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::CGIAssocEditClick(TObject *Sender)
{
    AnsiString tmp, exts, app;
    char *qcapt, *qtext;
    char *wcapt, *wtext;
    bool queryOK;
    int itind, colonPos;
    itind=CGIAssocListBox->ItemIndex;
    if (itind==-1)
    {
      //
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " -?";
        wtext = "     !";
      break;
      case 2: //by
        wcapt = " -?";
        wtext = "     !";
      break;
      case 3: //srb
        wcapt = "   ?";
        wtext = "    !";
      break;
      case 4: //ua
        wcapt = " -?";
        wtext = "    !";
      break;
      case 5: //bg
        wcapt = "  ?";
        wtext = "      !";
      break;
      default: //en
        wcapt = "What to edit?";
        wtext = "No one of associations is selected!";
      }
      Application->MessageBox(wtext, wcapt,
        MB_OK | MB_ICONWARNING);
      return;
    }
    tmp = CGIAssocListBox->Items->Strings[itind];
    colonPos = tmp.Pos(":");
    if (colonPos>0)
    {
        exts = tmp.SubString(1, colonPos-1);
        app = tmp.SubString(colonPos+1, tmp.Length()-colonPos);
    }
    else
        exts = tmp;
    //
    switch (Form1->Lang)
    {
    case 0: //ru
        qcapt = " CGI ,  1";
        qtext = "  ( ):";
    break;
    case 2: //by
        qcapt = " CGI ,  1";
        qtext = "  ( ):";
    break;
    case 3: //srb
        qcapt = "  ,  1";
        qtext = "  ( ):";
    break;
    case 4: //ua
        qcapt = " CGI ,  1";
        qtext = "  ( ):";
    break;
    case 5: //bg
        qcapt = "  CGI ,  1";
        qtext = "  (  ):";
    break;
    default: //en
        qcapt = "Editing CGI association, step 1";
        qtext = "File extensions (comma-separated):";
    }
    queryOK = InputQuery(qcapt, qtext, exts);
    if (queryOK)
    {
      //
      switch (Form1->Lang)
      {
      case 0: //ru
        qcapt = " CGI ,  2";
        qtext = " (  ) exe-:";
      break;
      case 2: //by
        qcapt = " CGI ,  2";
        qtext = " (  ) exe-:";
      break;
      case 3: //srb
        qcapt = "  ,  2";
        qtext = " (  )  :";
      break;
      case 4: //ua
        qcapt = " CGI ,  2";
        qtext = "' (  ) exe-:";
      break;
      case 5: //bg
        qcapt = "  CGI ,  2";
        qtext = " (  ) exe-app:";
      break;
      default: //en
        qcapt = "Editing CGI association, step 2";
        qtext = "Name (or full path) of exe-application:";
      }
      queryOK = InputQuery(qcapt, qtext, app);
    }
    if (queryOK)
    {
      //
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " !";
        wtext = "   \n"
            "  !";
      break;
      case 2: //by
        wcapt = " ˲˲!";
        wtext = "   \n"
            "  !";
      break;
      case 3: //srb
        wcapt = " !";
        wtext = "    \n"
            "  !";
      break;
      case 4: //ua
        wcapt = " !";
        wtext = "    \n"
            "  !";
      break;
      case 5: //bg
        wcapt = "!";
        wtext = "      \n"
            "   !";
      break;
      default: //en
        wcapt = "YOU`VE MADE A MISTAKE!";
        wtext = "Empty strings are not allowed\n"
            "Association has NOT been changed!";
      }
      if (exts.IsEmpty() || app.IsEmpty())
        Application->MessageBox(wtext, wcapt,
          MB_OK | MB_ICONWARNING);
      else
        CGIAssocListBox->Items->Strings[itind] = exts+":"+app;
    }
}//end TOptionsForm::CGIAssocEditClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::CGIAssocRemoveClick(TObject *Sender)
{
    int itind;
    itind=CGIAssocListBox->ItemIndex;
    if (itind==-1)
    {
      //
      char *wcapt, *wtext;
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " ,  ";
        wtext = "     !";
      break;
      case 2: //by
        wcapt = " ,  ";
        wtext = "     !";
      break;
      case 3: //srb
        wcapt = "    ";
        wtext = "    !";
      break;
      case 4: //ua
        wcapt = " ,  ";
        wtext = "    !";
      break;
      case 5: //bg
        wcapt = "    ";
        wtext = "      !";
      break;
      default: //en
        wcapt = "I don't know what to remove";
        wtext = "No one of associations is selected!";
      }
      Application->MessageBox(wtext, wcapt,
        MB_OK | MB_ICONWARNING);
    }
    else
        CGIAssocListBox->Items->Delete(itind);
}//end TOptionsForm::CGIAssocRemoveClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::CGIAssocClearClick(TObject *Sender)
{
    char *wcapt, *wtext;
    if (CGIAssocListBox->Items->Count==0)
    {
      //
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " !";
        wtext = " CGI  ";
      break;
      case 2: //by
        wcapt = "  !";
        wtext = " CGI  ";
      break;
      case 3: //srb
        wcapt = "  !";
        wtext = "    ";
      break;
      case 4: //ua
        wcapt = "ͳ !";
        wtext = " CGI  ";
      break;
      case 5: //bg
        wcapt = "   !";
        wtext = "  CGI   ";
      break;
      default: //en
        wcapt = "There`s no thing to remove!";
        wtext = "CGI association list is empty";
      }
        Application->MessageBox(wtext, wcapt,
          MB_OK | MB_ICONWARNING);
    }
    else
    {
      //
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " CGI ";
        wtext = "   !\n"
            "?";
      break;
      case 2: //by
        wcapt = " CGI ";
        wtext = "   !\n"
            "?";
      break;
      case 3: //srb
        wcapt = "  ";
        wtext = "    !\n"
            "?";
      break;
      case 4: //ua
        wcapt = " CGI ";
        wtext = "   !\n"
            "ϳ?";
      break;
      case 5: //bg
        wcapt = "  CGI ";
        wtext = "    !\n"
            " ?";
      break;
      default: //en
        wcapt = "Clearing CGI associations";
        wtext = "All associations would be removed!\n"
             "Do You confirm?";
      }
        if ( Application->MessageBox(wtext, wcapt,
            MB_YESNO | MB_ICONQUESTION)==IDYES )
          CGIAssocListBox->Items->Clear();
    }
}//end TOptionsForm::CGIAssocClearClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::RemoveRootButtonClick(TObject *Sender)
{
    int itind;
    char *wcapt, *wtext;
    itind=ListBoxRoots->ItemIndex;
    if (itind==-1)
    {
      //
      switch (Form1->Lang)
      {
      case 0: //ru
        wcapt = " ,  ";
        wtext = "  -  !";
      break;
      case 2: //by
        wcapt = " ,  ";
        wtext = "ͳ  -  !";
      break;
      case 3: //srb
        wcapt = "    ";
        wtext = " -  !";
      break;
      case 4: //ua
        wcapt = " ,  ";
        wtext = " -  !";
      break;
      case 5: //bg
        wcapt = "    ";
        wtext = " -  !";
      break;
      default: //en
        wcapt = "I don't know what to remove";
        wtext = "No root in list is selected!";
      }
      Application->MessageBox(wtext, wcapt,
        MB_OK | MB_ICONWARNING);
    }
    else
        ListBoxRoots->Items->Delete(itind);
}//end TOptionsForm::RemoveRootButtonClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::AddRootButtonClick(TObject *Sender)
{
//    RootPath
    char *rttext;
    char *rtcapt;
    if (RootPath->Text.IsEmpty())
    {
      switch (Form1->Lang)
      {
      case 0: //ru
        rttext = "  '  ' ";
        rtcapt = "";
      break;
      case 2: //by
        rttext = "  '  '  ";
        rtcapt = "";
      break;
      case 3: //srb
        rttext = "  '  ' ";
        rtcapt = "";
      break;
      case 4: //ua
        rttext = "  '  '  ";
        rtcapt = "";
      break;
      case 5: //bg
        rttext = "  '   ' ";
        rtcapt = "";
      break;
      default: //en
        rttext = "Fill 'Server root path' field please";
        rtcapt = "ERROR";
      }
      Application->MessageBox(
            rttext,
            rtcapt,
            MB_OK | MB_ICONERROR);
      return;
    }//end if
    else
    {
      ListBoxRoots->Items->Add(RootPath->Text);
    }//end else
}//end TOptionsForm::AddRootButtonClick
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::ListBoxRootsClick(TObject *Sender)
{
    int itind;
    char *rttext;
    char *rtcapt;
    itind=ListBoxRoots->ItemIndex;
    if (itind<0)
    {
      switch (Form1->Lang)
      {
      case 0: //ru
        rtcapt = "";
      break;
      case 2: //by
        rtcapt = "";
      break;
      case 3: //srb
        rtcapt = "";
      break;
      case 4: //ua
        rtcapt = "";
      break;
      case 5: //bg
        rtcapt = "";
      break;
      default: //en
        rtcapt = "ERROR";
      }
      rttext = "debug. itind<0";
      Application->MessageBox(
            rttext,
            rtcapt,
            MB_OK | MB_ICONWARNING);
      return;
    }//end if
    else
    {
      RootPath->Text = ListBoxRoots->Items->Strings[itind];
    }//end else
}//end TOptionsForm::ListBoxRootsClick
//---------------------------------------------------------------------------


void __fastcall TOptionsForm::Button404Click(TObject *Sender)
{
  if (OpenDialog1->Execute())
    File404Edit->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::Button500Click(TObject *Sender)
{
  if (OpenDialog1->Execute())
    File500Edit->Text = OpenDialog1->FileName;  
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::Button403Click(TObject *Sender)
{
  if (OpenDialog1->Execute())
    File403Edit->Text = OpenDialog1->FileName;
}
//---------------------------------------------------------------------------

void __fastcall TOptionsForm::CheckBox403Click(TObject *Sender)
{
  File403Edit->Visible = CheckBox403->Checked;
  Button403->Visible = CheckBox403->Checked;
}
//---------------------------------------------------------------------------

